---
product: "AG Charts"
title: "Zoom"
description: "Zoom into JavaScript charts to navigate large datasets; supports mouse scrolling, panning, selecting, and dragging or enable the navigator / context menu."
enterprise: true
framework: javascript
version: "14.2.0"
related:
    - title: "Accessibility"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/accessibility/"
    - title: "Localisation"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/localisation/"
    - title: "Series Highlighting"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/series-highlighting/"
    - title: "Tooltips"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/tooltips/"
    - title: "Touch"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/touch/"
    - title: "Animation"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/animation/"
    - title: "Context Menu"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/context-menu/"
    - title: "Crosshairs & Band Highlight"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/axes-crosshairs/"
    - title: "Data Selection"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/selection/"
    - title: "Flash On Update"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/flash-on-update/"
    - title: "Navigator"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/navigator/"
    - title: "Range Controls"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/range-controls/"
    - title: "Scrollbar"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/scrollbar/"
    - title: "Synchronization"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/sync/"
llms: "https://www.ag-grid.com/charts/archive/14.2.0/llms.txt"
---

# Zoom

AG Charts allows zooming into charts, making it easier to navigate large datasets.

#### Zoom

```ts
import {
  AgCartesianChartOptions,
  AgCharts,
  AnimationModule,
  ContextMenuModule,
  CrosshairModule,
  LegendModule,
  LineSeriesModule,
  ModuleRegistry,
  NumberAxisModule,
  ZoomModule,
} from "ag-charts-enterprise";
import { getData } from "./data";

ModuleRegistry.registerModules([
  AnimationModule,
  CrosshairModule,
  LegendModule,
  LineSeriesModule,
  NumberAxisModule,
  ZoomModule,
  ContextMenuModule,
]);

const options: AgCartesianChartOptions = {
  zoom: {
    enabled: true,
  },
  tooltip: {
    enabled: false,
  },
  axes: {
    x: {
      type: "number",
      nice: false,
      interval: {
        minSpacing: 80,
        maxSpacing: 120,
      },
      label: {
        autoRotate: false,
      },
    },
  },
  data: getData(),
  series: [
    {
      type: "line",
      xKey: "year",
      yKey: "spending",
    },
  ],
};

options.container = document.getElementById("myChart");

const chart = AgCharts.create(options);
```

[Live example: Zoom](https://www.ag-grid.com/charts/archive/14.2.0/typescript/zoom/examples/zoom/)

To enable this feature, set `zoom.enabled` to `true`.

```js
{
    zoom: {
        enabled: true,
    },
}
```

In the above example you can:

- Scroll in and out with the mouse wheel or trackpad.
- Zoom and pan using [touch and multi-touch](https://www.ag-grid.com/charts/archive/14.2.0/javascript/touch/) functionality.
- Use `+` and `-` keys to zoom in or out (when in focus).
- Click and drag the mouse to pan around the zoomed in chart.
- Click (or touch) and drag an axis to zoom in or out on only that axis.
- Double click (or double tap) anywhere to reset the zoom.
- Double click (or double tap) an axis to reset the zoom on only that axis.

> **Note**
>
> If `axis[].tick.maxSpacing` is provided, the axis ticks and labels will update with the zoom.

## Scrolling

This allows zooming by using the mouse wheel or trackpad, as shown in the above example and is enabled by default. To disable, use `enableScrolling: false`.

### Anchor Point

By default, the chart will zoom while keeping the right side of the x-axis pinned. You can change this anchor point with the `anchorPointX` and `anchorPointY` properties, setting them each to one of:

- `start`, the left or bottom of the chart when scrolling on the x-axis or y-axis respectively,
- `middle` (default for y-axis), the middle of the chart,
- `end` (default for x-axis), the right or top of the chart when scrolling on the x-axis or y-axis respectively,
- `pointer`, keep the mouse pointer above the same position on the chart when zooming.

In the example below, we set the anchor point for both axes to the mouse pointer.

#### Zoom Anchor Point

```ts
import {
  AgCartesianChartOptions,
  AgCharts,
  AnimationModule,
  CategoryAxisModule,
  ContextMenuModule,
  CrosshairModule,
  LegendModule,
  LineSeriesModule,
  ModuleRegistry,
  NumberAxisModule,
  ZoomModule,
} from "ag-charts-enterprise";
import { getData } from "./data";

ModuleRegistry.registerModules([
  AnimationModule,
  CategoryAxisModule,
  CrosshairModule,
  LegendModule,
  LineSeriesModule,
  NumberAxisModule,
  ZoomModule,
  ContextMenuModule,
]);

const options: AgCartesianChartOptions = {
  zoom: {
    enabled: true,
    axes: "xy",
    anchorPointX: "pointer",
    anchorPointY: "pointer",
  },
  tooltip: {
    enabled: false,
  },
  axes: {
    y: {
      type: "number",
      interval: {
        minSpacing: 80,
        maxSpacing: 120,
      },
    },
    x: {
      type: "number",
      nice: false,
      interval: {
        minSpacing: 80,
        maxSpacing: 120,
      },
      label: {
        autoRotate: false,
      },
    },
  },
  data: getData(),
  series: [
    {
      type: "line",
      xKey: "year",
      yKey: "spending",
    },
  ],
};

options.container = document.getElementById("myChart");

const chart = AgCharts.create(options);
```

[Live example: Zoom Anchor Point](https://www.ag-grid.com/charts/archive/14.2.0/typescript/zoom/examples/zoom-anchor-point/)

```js
{
    zoom: {
        anchorPointX: 'pointer',
        anchorPointY: 'pointer',
    },
}
```

### Scrolling Step

When scrolling, the chart zooms in by a single step for each movement of the scroll wheel or trackpad. By default `scrollingStep` is set to `0.1`, or 10% of the chart each time.

In the example below, we change the step to `0.4`.

#### Zoom Scrolling Step

```ts
import {
  AgCartesianChartOptions,
  AgCharts,
  AnimationModule,
  ContextMenuModule,
  CrosshairModule,
  LegendModule,
  LineSeriesModule,
  ModuleRegistry,
  NumberAxisModule,
  ZoomModule,
} from "ag-charts-enterprise";
import { getData } from "./data";

ModuleRegistry.registerModules([
  AnimationModule,
  CrosshairModule,
  LegendModule,
  LineSeriesModule,
  NumberAxisModule,
  ZoomModule,
  ContextMenuModule,
]);

const options: AgCartesianChartOptions = {
  zoom: {
    enabled: true,
    scrollingStep: 0.4,
  },
  tooltip: {
    enabled: false,
  },
  axes: {
    y: {
      type: "number",
      interval: {
        minSpacing: 80,
        maxSpacing: 120,
      },
    },
    x: {
      type: "number",
      nice: false,
      interval: {
        minSpacing: 80,
        maxSpacing: 120,
      },
      label: {
        autoRotate: false,
      },
    },
  },
  data: getData(),
  series: [
    {
      type: "line",
      xKey: "year",
      yKey: "spending",
    },
  ],
};

options.container = document.getElementById("myChart");

const chart = AgCharts.create(options);
```

[Live example: Zoom Scrolling Step](https://www.ag-grid.com/charts/archive/14.2.0/typescript/zoom/examples/zoom-scrolling-step/)

```js
{
    zoom: {
        scrollingStep: 0.4,
    },
}
```

### Axes

By default, scrolling zoom is only enabled for the `x` axis. This can be changed by setting the `axes` property to `x`, `y` or `xy`.

In the example below, we enable zoom on both the `x` and `y` axes.

#### Zoom Axes

```ts
import {
  AgCartesianChartOptions,
  AgCharts,
  AnimationModule,
  CategoryAxisModule,
  ContextMenuModule,
  CrosshairModule,
  LegendModule,
  LineSeriesModule,
  ModuleRegistry,
  NumberAxisModule,
  ZoomModule,
} from "ag-charts-enterprise";
import { getData } from "./data";

ModuleRegistry.registerModules([
  AnimationModule,
  CategoryAxisModule,
  CrosshairModule,
  LegendModule,
  LineSeriesModule,
  NumberAxisModule,
  ZoomModule,
  ContextMenuModule,
]);

const options: AgCartesianChartOptions = {
  zoom: {
    enabled: true,
    axes: "xy",
  },
  tooltip: {
    enabled: false,
  },
  axes: {
    y: {
      type: "number",
      interval: {
        minSpacing: 80,
        maxSpacing: 120,
      },
    },
    x: {
      type: "number",
      nice: false,
      interval: {
        minSpacing: 80,
        maxSpacing: 120,
      },
      label: {
        autoRotate: false,
      },
    },
  },
  data: getData(),
  series: [
    {
      type: "line",
      xKey: "year",
      yKey: "spending",
    },
  ],
};

options.container = document.getElementById("myChart");

const chart = AgCharts.create(options);
```

[Live example: Zoom Axes](https://www.ag-grid.com/charts/archive/14.2.0/typescript/zoom/examples/zoom-axes/)

```js
{
    zoom: {
        axes: 'xy',
    },
}
```

### Scrolling Mode

By default, vertical mouse wheel or trackpad scrolling zooms the chart. Set `scrollingMode: 'pan'` to pan instead.

#### Zoom Scrolling Mode

```ts
import {
  AgCartesianChartOptions,
  AgCharts,
  AnimationModule,
  BarSeriesModule,
  CategoryAxisModule,
  ContextMenuModule,
  ModuleRegistry,
  NumberAxisModule,
  ZoomModule,
} from "ag-charts-enterprise";
import { getData } from "./data";

ModuleRegistry.registerModules([
  AnimationModule,
  BarSeriesModule,
  CategoryAxisModule,
  NumberAxisModule,
  ZoomModule,
  ContextMenuModule,
]);

const options: AgCartesianChartOptions = {
  zoom: {
    enabled: true,
    scrollingMode: "zoom",
  },
  title: {
    text: "Population by Country (millions)",
  },
  initialState: {
    zoom: {
      ratioY: { start: 0.6 },
    },
  },
  axes: {
    x: {
      type: "number",
      label: {
        formatter: (params) => `${params.value}M`,
      },
    },
  },
  data: getData(),
  series: [
    {
      type: "bar",
      direction: "horizontal",
      xKey: "country",
      yKey: "population",
      yName: "Population (millions)",
    },
  ],
};

options.container = document.getElementById("myChart");

const chart = AgCharts.create(options);

function setScrollingMode(event: Event) {
  options.zoom!.scrollingMode = (event.target as HTMLInputElement).value as
    | "zoom"
    | "pan";

  chart.update(options);
}

if (typeof window !== "undefined") {
  // Attach external event handlers to window so they can be called from index.html
  (<any>window).setScrollingMode = setScrollingMode;
}
```

[Live example: Zoom Scrolling Mode](https://www.ag-grid.com/charts/archive/14.2.0/typescript/zoom/examples/zoom-scrolling-mode/)

```js
{
    zoom: {
        scrollingMode: 'pan',
    },
}
```

## Panning

This is enabled by default and allows users to click and drag to move around a zoomed chart. To disable, use `enablePanning: false`.

If [zoom by selecting](https://www.ag-grid.com/charts/archive/14.2.0/javascript/zoom/#selecting) is enabled, clicking and dragging will no longer pan by default. Instead the user will need to hold down a key to switch to panning mode.

This key defaults to `alt` but can be set with the `panKey` property to one of `alt`, `ctrl`, `shift` or `meta` (the command key on MacOS or start key on Windows).

In the example below, panning can only be done by holding down the `shift` key while clicking and dragging.

#### Zoom Pan Key

```ts
import {
  AgCartesianChartOptions,
  AgCharts,
  AnimationModule,
  ContextMenuModule,
  CrosshairModule,
  LegendModule,
  LineSeriesModule,
  ModuleRegistry,
  NumberAxisModule,
  ZoomModule,
} from "ag-charts-enterprise";
import { getData } from "./data";

ModuleRegistry.registerModules([
  AnimationModule,
  CrosshairModule,
  LegendModule,
  LineSeriesModule,
  NumberAxisModule,
  ZoomModule,
  ContextMenuModule,
]);

const options: AgCartesianChartOptions = {
  zoom: {
    enabled: true,
    enableSelecting: true,
    panKey: "shift",
  },
  tooltip: {
    enabled: false,
  },
  axes: {
    y: {
      type: "number",
      interval: {
        minSpacing: 80,
        maxSpacing: 120,
      },
    },
    x: {
      type: "number",
      nice: false,
      interval: {
        minSpacing: 80,
        maxSpacing: 120,
      },
      label: {
        autoRotate: false,
      },
    },
  },
  data: getData(),
  series: [
    {
      type: "line",
      xKey: "year",
      yKey: "spending",
    },
  ],
};

options.container = document.getElementById("myChart");

const chart = AgCharts.create(options);
```

[Live example: Zoom Pan Key](https://www.ag-grid.com/charts/archive/14.2.0/typescript/zoom/examples/zoom-pan-key/)

```js
{
    zoom: {
        panKey: 'shift',
    },
}
```

## Selecting

This method of zooming works by clicking and dragging a box to select an area on the chart. This is disabled by default. To enable, use `enableSelecting: true`.

In the example below, the user can only zoom in by selection, and can only zoom out by double-click to reset.

#### Zoom Selecting

```ts
import {
  AgCartesianChartOptions,
  AgCharts,
  AnimationModule,
  ContextMenuModule,
  CrosshairModule,
  LegendModule,
  LineSeriesModule,
  ModuleRegistry,
  NumberAxisModule,
  ZoomModule,
} from "ag-charts-enterprise";
import { getData } from "./data";

ModuleRegistry.registerModules([
  AnimationModule,
  CrosshairModule,
  LegendModule,
  LineSeriesModule,
  NumberAxisModule,
  ZoomModule,
  ContextMenuModule,
]);

const options: AgCartesianChartOptions = {
  zoom: {
    enableAxisDragging: false,
    enablePanning: false,
    enableScrolling: false,
    enableSelecting: true,
  },
  tooltip: {
    enabled: false,
  },
  axes: {
    y: {
      type: "number",
      interval: {
        minSpacing: 80,
        maxSpacing: 120,
      },
    },
    x: {
      type: "number",
      nice: false,
      interval: {
        minSpacing: 80,
        maxSpacing: 120,
      },
      label: {
        autoRotate: false,
      },
    },
  },
  data: getData(),
  series: [
    {
      type: "line",
      xKey: "year",
      yKey: "spending",
    },
  ],
};

options.container = document.getElementById("myChart");

const chart = AgCharts.create(options);
```

[Live example: Zoom Selecting](https://www.ag-grid.com/charts/archive/14.2.0/typescript/zoom/examples/zoom-selecting/)

```js
{
    zoom: {
        enableAxisDragging: false,
        enablePanning: false,
        enableScrolling: false,
        enableSelecting: true,
    },
}
```

## Two Finger Zoom-Pan

By default, using two fingers to pinch in or out will zoom the chart. It is also possible to use two fingers to pan a zoomed chart.

To disable this behaviour, use `enableTwoFingerZoom: false`.

#### Two Finger Zoom-Pan Disabled

```ts
import {
  AgCartesianChartOptions,
  AgCharts,
  AnimationModule,
  ContextMenuModule,
  CrosshairModule,
  LegendModule,
  LineSeriesModule,
  ModuleRegistry,
  NumberAxisModule,
  ZoomModule,
} from "ag-charts-enterprise";
import { getData } from "./data";

ModuleRegistry.registerModules([
  AnimationModule,
  CrosshairModule,
  LegendModule,
  LineSeriesModule,
  NumberAxisModule,
  ZoomModule,
  ContextMenuModule,
]);

const options: AgCartesianChartOptions = {
  zoom: {
    enableTwoFingerZoom: false,
  },
  initialState: {
    zoom: {
      ratioX: { start: 0.48, end: 0.52 },
      ratioY: { start: 0.21, end: 0.82 },
    },
  },
  tooltip: {
    enabled: false,
  },
  axes: {
    y: {
      type: "number",
      interval: {
        minSpacing: 80,
        maxSpacing: 120,
      },
    },
    x: {
      type: "number",
      nice: false,
      interval: {
        minSpacing: 80,
        maxSpacing: 120,
      },
      label: {
        autoRotate: false,
      },
    },
  },
  data: getData(),
  series: [
    {
      type: "line",
      xKey: "year",
      yKey: "spending",
    },
  ],
};

options.container = document.getElementById("myChart");

const chart = AgCharts.create(options);
```

[Live example: Two Finger Zoom-Pan Disabled](https://www.ag-grid.com/charts/archive/14.2.0/typescript/zoom/examples/two-finger-disabled/)

```js
{
    zoom: {
        enableTwoFingerZoom: false,
    },
}
```

In the above example:

- Two fingers gestures are not consumed by the chart. Instead they zoom or scroll the entire page.

## Axis Zoom Controls

By default, a user can click and drag on any axis to change the zoom of that axis. This ignores the `axes` property and is enabled by default for all axes.

#### Axis Zoom Controls

```ts
import {
  AgCartesianChartOptions,
  AgCharts,
  AnimationModule,
  ContextMenuModule,
  CrosshairModule,
  LegendModule,
  LineSeriesModule,
  ModuleRegistry,
  NumberAxisModule,
  ZoomModule,
} from "ag-charts-enterprise";
import { getData } from "./data";

ModuleRegistry.registerModules([
  AnimationModule,
  CrosshairModule,
  LegendModule,
  LineSeriesModule,
  NumberAxisModule,
  ZoomModule,
  ContextMenuModule,
]);

const options: AgCartesianChartOptions = {
  zoom: {
    enabled: true,
    enableAxisDragging: true,
    enableAxisScrolling: true,
    axisDraggingMode: "zoom",
  },
  tooltip: {
    enabled: false,
  },
  axes: {
    y: {
      type: "number",
      position: "left",
      title: {
        text: "Spending",
      },
      interval: {
        minSpacing: 80,
        maxSpacing: 120,
      },
    },
    ySecondary: {
      type: "number",
      position: "right",
      title: {
        text: "Tonnes",
      },
      interval: {
        minSpacing: 80,
        maxSpacing: 120,
      },
    },
    x: {
      type: "number",
      nice: false,
      interval: {
        minSpacing: 80,
        maxSpacing: 120,
      },
      label: {
        autoRotate: false,
      },
    },
  },
  data: getData(),
  series: [
    {
      type: "line",
      xKey: "year",
      yKey: "spending",
    },
    {
      type: "line",
      xKey: "year",
      yKey: "tonnes",
      yKeyAxis: "ySecondary",
    },
  ],
};

options.container = document.getElementById("myChart");

const chart = AgCharts.create(options);

function setAxisDragging(mode: "zoom" | "pan") {
  options.zoom!.axisDraggingMode = mode;

  chart.update(options);
}

function enableAxisDragging(enabled: "on" | "off") {
  options.zoom!.enableAxisDragging = enabled === "on";

  chart.update(options);
}

function enableAxisScrolling(enabled: "on" | "off") {
  options.zoom!.enableAxisScrolling = enabled === "on";

  chart.update(options);
}

if (typeof window !== "undefined") {
  // Attach external event handlers to window so they can be called from index.html
  (<any>window).setAxisDragging = setAxisDragging;
  (<any>window).enableAxisDragging = enableAxisDragging;
  (<any>window).enableAxisScrolling = enableAxisScrolling;
}
```

[Live example: Axis Zoom Controls](https://www.ag-grid.com/charts/archive/14.2.0/typescript/zoom/examples/zoom-axis-controls/)

- When using `axisDraggingMode: 'zoom'` (default), dragging either of the y-axes will zoom both of them.
- Use `axisDraggingMode: 'pan'` to pan while dragging an axis.
- Use `enableAxisDragging: false` to disable all axis dragging.
- Scrolling on an axis to zoom is enabled by default. Use `enableAxisScrolling: false` to disable it.

## Double-Click to Reset

This allows users to reset the zoom by double-clicking in an empty space in the chart area, and is enabled by default. To disable, use `enableDoubleClickToReset: false`.

## Minimum Visible Items

The `minVisibleItems` option can be used to limit how far a user can zoom in to the chart.

The example below demonstrates setting `minVisibleItems` to `10`, preventing the user from zooming beyond showing a minimum of 10 points on the line.

#### Zoom Min Visible Items

```ts
import {
  AgCartesianChartOptions,
  AgCharts,
  AnimationModule,
  ContextMenuModule,
  CrosshairModule,
  LegendModule,
  LineSeriesModule,
  ModuleRegistry,
  NumberAxisModule,
  ZoomModule,
} from "ag-charts-enterprise";
import { getData } from "./data";

ModuleRegistry.registerModules([
  AnimationModule,
  ContextMenuModule,
  CrosshairModule,
  LegendModule,
  LineSeriesModule,
  NumberAxisModule,
  ZoomModule,
]);

const options: AgCartesianChartOptions = {
  zoom: {
    minVisibleItems: 10,
  },
  tooltip: {
    enabled: false,
  },
  axes: {
    y: {
      type: "number",
      interval: {
        minSpacing: 80,
        maxSpacing: 120,
      },
    },
    x: {
      type: "number",
      nice: false,
      interval: {
        minSpacing: 80,
        maxSpacing: 120,
      },
      label: {
        autoRotate: false,
      },
    },
  },
  data: getData(),
  series: [
    {
      type: "line",
      xKey: "year",
      yKey: "spending",
    },
  ],
};

options.container = document.getElementById("myChart");

const chart = AgCharts.create(options);
```

[Live example: Zoom Min Visible Items](https://www.ag-grid.com/charts/archive/14.2.0/typescript/zoom/examples/zoom-min-visible-items/)

```js
{
    zoom: {
        minVisibleItems: 10,
    },
}
```

## Auto Scaling

Auto Scaling dynamically adjusts the y-axis to fit the visible data whenever the x-axis is zoomed or panned. This is enabled by default when zooming the x-axis. To disable, use `autoScaling: false`.

#### Auto Scaling

```ts
import {
  AgCartesianChartOptions,
  AgCharts,
  AnimationModule,
  CandlestickSeriesModule,
  ContextMenuModule,
  CrosshairModule,
  LegendModule,
  ModuleRegistry,
  NavigatorModule,
  NumberAxisModule,
  OrdinalTimeAxisModule,
  ZoomModule,
} from "ag-charts-enterprise";
import { getData } from "./data";

ModuleRegistry.registerModules([
  AnimationModule,
  CandlestickSeriesModule,
  CrosshairModule,
  LegendModule,
  NavigatorModule,
  NumberAxisModule,
  OrdinalTimeAxisModule,
  ZoomModule,
  ContextMenuModule,
]);

const options: AgCartesianChartOptions = {
  data: getData(1e3),
  animation: { enabled: false },
  zoom: {
    enabled: true,
    anchorPointX: "pointer",
    anchorPointY: "pointer",
    autoScaling: {
      enabled: true,
    },
  },
  navigator: {
    enabled: true,
    miniChart: {
      enabled: true,
    },
  },
  series: [
    {
      type: "candlestick",
      xKey: "timestamp",
      lowKey: "low",
      highKey: "high",
      openKey: "open",
      closeKey: "close",
    },
  ],
};

options.container = document.getElementById("myChart");

const chart = AgCharts.create(options);

function setAutoScaling(event: Event) {
  const autoScaling = (event.target as HTMLInputElement).value === "true";
  options.zoom!.autoScaling!.enabled = autoScaling;

  chart.update(options);
}

if (typeof window !== "undefined") {
  // Attach external event handlers to window so they can be called from index.html
  (<any>window).setAutoScaling = setAutoScaling;
}
```

[Live example: Auto Scaling](https://www.ag-grid.com/charts/archive/14.2.0/typescript/zoom/examples/auto-scaling/)

```js
{
    zoom: {
        autoScaling: {
            enabled: false,
        },
    },
}
```

In the above example:

- Zoom in to the chart by scrolling and then pan left and right.
- Observe how the vertical axis domain changes to fit the displayed data range.

Auto Scaling is never applied when the user has manually adjusted the y-axis by dragging it. Auto Scaling will be reapplied when the y-axis is reset, for example by double clicking on it.

## On Data Change

When data is updated while the chart is zoomed, the `zoom.onDataChange` options control how the zoomed view adjusts. This helps users maintain their focus when data changes, or always see the latest data.

The default strategy is `preserveDomain`, use `onDataChange.strategy` to change to one of the below.

### Preserve Domain

`strategy: 'preserveDomain'` preserves the current axis domain when data changes, keeping the view at the exact domain values if possible.

This is useful for appending data without disrupting users viewing a specific time period in the middle of the data.

#### Preserve Domain

```ts
import {
  AgCartesianChartOptions,
  AgCharts,
  LineSeriesModule,
  ModuleRegistry,
  NavigatorModule,
  NumberAxisModule,
  TimeAxisModule,
  ZoomModule,
} from "ag-charts-enterprise";
import { getData, getNextDataPoint } from "./data";

let data = getData();
let streamingInterval: ReturnType<typeof setInterval> | null = null;
ModuleRegistry.registerModules([
  LineSeriesModule,
  NavigatorModule,
  NumberAxisModule,
  TimeAxisModule,
  ZoomModule,
]);

const options: AgCartesianChartOptions = {
  data,
  series: [
    {
      type: "line",
      xKey: "date",
      yKey: "price",
      marker: { enabled: false },
    },
  ],
  axes: {
    x: {
      type: "time",
      nice: false,
    },
    y: {
      type: "number",
      title: { text: "Price" },
    },
  },
  zoom: {
    enabled: true,
    onDataChange: {
      strategy: "preserveDomain",
    },
  },
  navigator: {
    enabled: true,
    miniChart: {
      enabled: true,
    },
  },
  initialState: {
    zoom: {
      ratioX: { start: 0.3, end: 0.7 },
    },
  },
};

options.container = document.getElementById("myChart");

const chart = AgCharts.create(options);

function startUpdates() {
  if (streamingInterval) return;
  streamingInterval = setInterval(() => {
    const nextPoint = getNextDataPoint(data);
    data.push(nextPoint);
    chart.applyTransaction({ add: [nextPoint] });
  }, 100);
}

function stopUpdates() {
  if (streamingInterval) {
    clearInterval(streamingInterval);
    streamingInterval = null;
  }
}

function resetData() {
  stopUpdates();
  data = getData();
  options.data = data;

  chart.update(options);
}

if (typeof window !== "undefined") {
  // Attach external event handlers to window so they can be called from index.html
  (<any>window).startUpdates = startUpdates;
  (<any>window).stopUpdates = stopUpdates;
  (<any>window).resetData = resetData;
}
```

[Live example: Preserve Domain](https://www.ag-grid.com/charts/archive/14.2.0/typescript/zoom/examples/on-data-change-preserve-domain/)

```js
{
    zoom: {
        enabled: true,
        onDataChange: {
            strategy: 'preserveDomain',
        },
    },
}
```

In this example:

- The chart is initially zoomed to the middle of the data.
- Start the updates to see new data appended at the end.
- Notice in the Navigator that new data has been added, but the chart view remains fixed on the same time range.

### Preserve Ratios

`strategy: 'preserveRatios'`, preserves the same zoom percentages regardless of data changes.

This is useful for maintaining a consistent proportional view of your data, with more data points becoming visible as the dataset grows.

#### Preserve Ratios

```ts
import {
  AgCartesianChartOptions,
  AgCharts,
  LineSeriesModule,
  ModuleRegistry,
  NavigatorModule,
  NumberAxisModule,
  TimeAxisModule,
  ZoomModule,
} from "ag-charts-enterprise";
import { getData, getNextDataPoint } from "./data";

let data = getData();
let streamingInterval: ReturnType<typeof setInterval> | null = null;
ModuleRegistry.registerModules([
  LineSeriesModule,
  NavigatorModule,
  NumberAxisModule,
  TimeAxisModule,
  ZoomModule,
]);

const options: AgCartesianChartOptions = {
  data,
  series: [
    {
      type: "line",
      xKey: "date",
      yKey: "price",
      marker: { enabled: false },
    },
  ],
  axes: {
    x: {
      type: "time",
      nice: false,
    },
    y: {
      type: "number",
      title: { text: "Price" },
    },
  },
  zoom: {
    enabled: true,
    onDataChange: {
      strategy: "preserveRatios",
    },
  },
  navigator: {
    enabled: true,
    miniChart: {
      enabled: true,
    },
  },
  initialState: {
    zoom: {
      ratioX: { start: 0.8, end: 1 },
    },
  },
};

options.container = document.getElementById("myChart");

const chart = AgCharts.create(options);

function startUpdates() {
  if (streamingInterval) return;
  streamingInterval = setInterval(() => {
    const newPoints = [];
    for (let i = 0; i < 10; i++) {
      const nextPoint = getNextDataPoint(data);
      data.push(nextPoint);
      newPoints.push(nextPoint);
    }
    chart.applyTransaction({ add: newPoints });
  }, 200);
}

function stopUpdates() {
  if (streamingInterval) {
    clearInterval(streamingInterval);
    streamingInterval = null;
  }
}

function resetData() {
  stopUpdates();
  data = getData();
  options.data = data;

  chart.update(options);
}

if (typeof window !== "undefined") {
  // Attach external event handlers to window so they can be called from index.html
  (<any>window).startUpdates = startUpdates;
  (<any>window).stopUpdates = stopUpdates;
  (<any>window).resetData = resetData;
}
```

[Live example: Preserve Ratios](https://www.ag-grid.com/charts/archive/14.2.0/typescript/zoom/examples/on-data-change-preserve-ratio/)

```js
{
    zoom: {
        enabled: true,
        onDataChange: {
            strategy: 'preserveRatios',
        },
    },
}
```

In this example:

- The chart is initially zoomed to the last 20% of the data.
- Start the updates to see new data points added in batches.
- Notice that more data points become visible in the chart view as total data grows, since the zoom ratio stays at 80%-100%.

### Reset

`strategy: 'reset'`, resets the zoom to the `initialState` or no zoom, whenever the data changes.

This is useful for switching between unrelated datasets, discarding previous user interactions and reverting to a predefined starting view.

#### Reset

```ts
import {
  AgCartesianChartOptions,
  AgCharts,
  LineSeriesModule,
  ModuleRegistry,
  NavigatorModule,
  NumberAxisModule,
  TimeAxisModule,
  ZoomModule,
} from "ag-charts-enterprise";
import { getDatasetA, getDatasetB } from "./data";

ModuleRegistry.registerModules([
  LineSeriesModule,
  NavigatorModule,
  NumberAxisModule,
  TimeAxisModule,
  ZoomModule,
]);

const options: AgCartesianChartOptions = {
  data: getDatasetA(),
  series: [
    {
      type: "line",
      xKey: "date",
      yKey: "price",
      marker: { enabled: false },
    },
  ],
  axes: {
    x: {
      type: "time",
      nice: false,
    },
    y: {
      type: "number",
      title: { text: "Price" },
    },
  },
  zoom: {
    enabled: true,
    onDataChange: {
      strategy: "reset",
    },
  },
  navigator: {
    enabled: true,
    miniChart: {
      enabled: true,
    },
  },
  initialState: {
    zoom: {
      ratioX: { start: 0.9, end: 1 },
    },
  },
};

options.container = document.getElementById("myChart");

const chart = AgCharts.create(options);

function loadDatasetA() {
  options.data = getDatasetA();

  chart.update(options);
}

function loadDatasetB() {
  options.data = getDatasetB();

  chart.update(options);
}

if (typeof window !== "undefined") {
  // Attach external event handlers to window so they can be called from index.html
  (<any>window).loadDatasetA = loadDatasetA;
  (<any>window).loadDatasetB = loadDatasetB;
}
```

[Live example: Reset](https://www.ag-grid.com/charts/archive/14.2.0/typescript/zoom/examples/on-data-change-reset/)

```js
{
    zoom: {
        enabled: true,
        onDataChange: {
            strategy: 'reset',
        },
    },
}
```

In this example:

- The chart is initially zoomed to show only the last few data points.
- Pan or zoom to a different position in the chart.
- Click a button to switch datasets and notice that the zoom resets to the initial state.

### Stick to End

The `stickToEnd` option automatically scrolls to keep the latest data visible when new data is appended and the view is already at the end of the data range. Use `stickToEnd: true` to enable.

When `stickToEnd` is active, it takes precedence over the configured strategy. Once the user pans away from the end, the configured strategy (e.g., `preserveDomain`) takes over until they return to viewing the end.

#### Stick to End

```ts
import {
  AgCartesianChartOptions,
  AgCharts,
  LineSeriesModule,
  ModuleRegistry,
  NavigatorModule,
  NumberAxisModule,
  TimeAxisModule,
  ZoomModule,
} from "ag-charts-enterprise";
import { getData, getNextDataPoint } from "./data";

let data = getData();
let streamingInterval: ReturnType<typeof setInterval> | null = null;
ModuleRegistry.registerModules([
  LineSeriesModule,
  NavigatorModule,
  NumberAxisModule,
  TimeAxisModule,
  ZoomModule,
]);

const options: AgCartesianChartOptions = {
  data,
  series: [
    {
      type: "line",
      xKey: "date",
      yKey: "price",
      marker: { enabled: false },
    },
  ],
  axes: {
    x: {
      type: "time",
      nice: false,
    },
    y: {
      type: "number",
      title: { text: "Price" },
    },
  },
  zoom: {
    enabled: true,
    onDataChange: {
      strategy: "preserveDomain",
      stickToEnd: true,
    },
  },
  navigator: {
    enabled: true,
    miniChart: {
      enabled: true,
    },
  },
  initialState: {
    zoom: {
      ratioX: { start: 0.6, end: 1 },
    },
  },
};

options.container = document.getElementById("myChart");

const chart = AgCharts.create(options);

function startUpdates() {
  if (streamingInterval) return;
  streamingInterval = setInterval(() => {
    const nextPoint = getNextDataPoint(data);
    data.push(nextPoint);
    chart.applyTransaction({ add: [nextPoint] });
  }, 100);
}

function stopUpdates() {
  if (streamingInterval) {
    clearInterval(streamingInterval);
    streamingInterval = null;
  }
}

function resetData() {
  stopUpdates();
  data = getData();
  options.data = data;

  chart.update(options);
}

if (typeof window !== "undefined") {
  // Attach external event handlers to window so they can be called from index.html
  (<any>window).startUpdates = startUpdates;
  (<any>window).stopUpdates = stopUpdates;
  (<any>window).resetData = resetData;
}
```

[Live example: Stick to End](https://www.ag-grid.com/charts/archive/14.2.0/typescript/zoom/examples/on-data-change-stick-to-end/)

```js
{
    zoom: {
        enabled: true,
        onDataChange: {
            strategy: 'preserveDomain',
            stickToEnd: true,
        },
    },
}
```

In this example:

- The chart is initially zoomed to the end of the data.
- Start the updates to see new data appended and the view scrolls to follow.
- Pan away from the end to see the `preserveDomain` strategy take over with a fixed view.
- Pan back to the end and the view will resume following new data.

## Navigator

The zoom functionality can be used together with the [Navigator](https://www.ag-grid.com/charts/archive/14.2.0/javascript/navigator/) to add a visual reference to the zoom position.

## Context Menu

When both the zoom and [Context Menu](https://www.ag-grid.com/charts/archive/14.2.0/javascript/context-menu/) are enabled, additional zoom actions are added into the Context Menu for zooming and panning to the clicked location.

#### Zoom Context Menu

```ts
import {
  AgCartesianChartOptions,
  AgCharts,
  AnimationModule,
  ContextMenuModule,
  CrosshairModule,
  LegendModule,
  LineSeriesModule,
  ModuleRegistry,
  NumberAxisModule,
  ZoomModule,
} from "ag-charts-enterprise";
import { getData } from "./data";

ModuleRegistry.registerModules([
  AnimationModule,
  ContextMenuModule,
  CrosshairModule,
  LegendModule,
  LineSeriesModule,
  NumberAxisModule,
  ZoomModule,
]);

const options: AgCartesianChartOptions = {
  zoom: {
    enabled: true,
  },
  contextMenu: {
    enabled: true,
  },
  tooltip: {
    enabled: false,
  },
  axes: {
    y: {
      type: "number",
      interval: {
        minSpacing: 80,
        maxSpacing: 120,
      },
    },
    x: {
      type: "number",
      nice: false,
      interval: {
        minSpacing: 80,
        maxSpacing: 120,
      },
      label: {
        autoRotate: false,
      },
    },
  },
  data: getData(),
  series: [
    {
      type: "line",
      xKey: "year",
      yKey: "spending",
    },
  ],
};

options.container = document.getElementById("myChart");

const chart = AgCharts.create(options);
```

[Live example: Zoom Context Menu](https://www.ag-grid.com/charts/archive/14.2.0/typescript/zoom/examples/zoom-context-menu/)

## Buttons

Zoom buttons are enabled by default. To disable, use `zoom.buttons.enabled: false`.

#### Zoom Buttons

```ts
import {
  AgCartesianChartOptions,
  AgCharts,
  AgZoomButtonsVisible,
  AnimationModule,
  ContextMenuModule,
  CrosshairModule,
  LegendModule,
  LineSeriesModule,
  ModuleRegistry,
  NumberAxisModule,
  UnitTimeAxisModule,
  ZoomModule,
} from "ag-charts-enterprise";
import { getData } from "./data";

ModuleRegistry.registerModules([
  AnimationModule,
  CrosshairModule,
  LegendModule,
  LineSeriesModule,
  NumberAxisModule,
  UnitTimeAxisModule,
  ZoomModule,
  ContextMenuModule,
]);

const options: AgCartesianChartOptions = {
  zoom: {
    enabled: true,
    buttons: {
      visible: "hover",
    },
  },
  tooltip: {
    enabled: false,
  },
  axes: {
    x: {
      type: "unit-time",
      interval: {
        minSpacing: 50,
        maxSpacing: 200,
      },
      label: {
        autoRotate: false,
      },
      crosshair: {
        label: {
          format: `%d %b %Y`,
        },
      },
    },
  },
  data: getData(),
  series: [
    {
      type: "line",
      xKey: "time",
      yKey: "price",
    },
  ],
};

options.container = document.getElementById("myChart");

const chart = AgCharts.create(options);

function changeVisible(event: Event) {
  options.zoom!.buttons!.visible = (event.target as HTMLInputElement)
    .value as AgZoomButtonsVisible;

  chart.update(options);
}

if (typeof window !== "undefined") {
  // Attach external event handlers to window so they can be called from index.html
  (<any>window).changeVisible = changeVisible;
}
```

[Live example: Zoom Buttons](https://www.ag-grid.com/charts/archive/14.2.0/typescript/zoom/examples/zoom-buttons/)

Hover near the bottom of the above example to see the default zoom buttons.

- **Zoom out**: Zooms the chart out by one [step](https://www.ag-grid.com/charts/archive/14.2.0/javascript/zoom/#scrolling-step).
- **Zoom in**: Zooms the chart in by one [step](https://www.ag-grid.com/charts/archive/14.2.0/javascript/zoom/#scrolling-step).
- **Pan left**: Pans the chart to the left by one [step](https://www.ag-grid.com/charts/archive/14.2.0/javascript/zoom/#scrolling-step).
- **Pan right**: Pans the chart to the right by one [step](https://www.ag-grid.com/charts/archive/14.2.0/javascript/zoom/#scrolling-step).
- **Reset**: Resets the zoom to the original level and position. Equivalent to [Double-Click to Reset](https://www.ag-grid.com/charts/archive/14.2.0/javascript/zoom/#double-click-to-reset).

To change when the buttons will appear, use `zoom.buttons.visible`:

- `always` – The buttons will always be visible.
- `zoomed` – The buttons will appear when the chart has been zoomed.
- `hover` – The buttons will appear when the mouse is hovered near the bottom of a chart which has zoom enabled.

### Customisation

It is possible to customise the visibility, order and grouping of buttons, as well as modifying the icon, label text and tooltip for each.

#### Customised Zoom Buttons

```ts
import {
  AgCartesianChartOptions,
  AgCharts,
  AnimationModule,
  ContextMenuModule,
  CrosshairModule,
  LegendModule,
  LineSeriesModule,
  ModuleRegistry,
  NumberAxisModule,
  UnitTimeAxisModule,
  ZoomModule,
} from "ag-charts-enterprise";
import { getData } from "./data";

ModuleRegistry.registerModules([
  AnimationModule,
  CrosshairModule,
  LegendModule,
  LineSeriesModule,
  NumberAxisModule,
  UnitTimeAxisModule,
  ZoomModule,
  ContextMenuModule,
]);

const options: AgCartesianChartOptions = {
  zoom: {
    enabled: true,
    buttons: {
      visible: "always",
      buttons: [
        {
          icon: "zoom-in",
          tooltip: "Decrease Visible Range",
          value: "zoom-in",
          label: "In",
          section: "zoom",
        },
        {
          icon: "zoom-out",
          tooltip: "Increase Visible Range",
          value: "zoom-out",
          label: "Out",
          section: "zoom",
        },
        {
          icon: "pan-start",
          tooltip: "Pan to Start",
          value: "pan-start",
          section: "pan",
        },
        {
          icon: "pan-end",
          tooltip: "Pan to End",
          value: "pan-end",
          section: "pan",
        },
        {
          tooltip: "Undo all Zoom",
          value: "reset",
          label: "Reset",
          section: "reset",
        },
      ],
    },
  },
  tooltip: {
    enabled: false,
  },
  axes: {
    x: {
      type: "unit-time",
      interval: {
        minSpacing: 50,
        maxSpacing: 200,
      },
      label: {
        autoRotate: false,
      },
      crosshair: {
        label: {
          format: `%d %b %Y`,
        },
      },
    },
  },
  data: getData(),
  series: [
    {
      type: "line",
      xKey: "time",
      yKey: "price",
    },
  ],
};

options.container = document.getElementById("myChart");

const chart = AgCharts.create(options);
```

[Live example: Customised Zoom Buttons](https://www.ag-grid.com/charts/archive/14.2.0/typescript/zoom/examples/zoom-custom-buttons/)

```js
{
    zoom: {
        buttons: {
            visible: 'always',
            buttons: [
                {
                    icon: 'zoom-in',
                    tooltip: 'Decrease Visible Range',
                    value: 'zoom-in',
                    label: 'In',
                    section: 'zoom',
                },
                {
                    icon: 'zoom-out',
                    tooltip: 'Increase Visible Range',
                    value: 'zoom-out',
                    label: 'Out',
                    section: 'zoom',
                },
                {
                    icon: 'pan-start',
                    tooltip: 'Pan to Start',
                    value: 'pan-start',
                    section: 'pan',
                },
                {
                    icon: 'pan-end',
                    tooltip: 'Pan to End',
                    value: 'pan-end',
                    section: 'pan',
                },
                {
                    tooltip: 'Undo all Zoom',
                    value: 'reset',
                    label: 'Reset',
                    section: 'reset',
                },
            ],
        },
    },
}
```

In the above example:

- The pan-left and pan-right buttons are not shown.
- Additional buttons are added to enable panning to the start and end of the x-axis.
- All the buttons have custom tooltip text.
- The order of the zoom-in and zoom-out buttons is swapped and they have a label as well as an icon.
- The reset button has only a label and no icon.

For more information see the [API Reference section](https://www.ag-grid.com/charts/archive/14.2.0/javascript/zoom/#reference-AgZoomOptions-buttons-buttons).

## Asynchronous Loading

For loading data asynchronously as the user zooms and pans, see [Asynchronous Data](https://www.ag-grid.com/charts/archive/14.2.0/javascript/async-data/).

## Save & Restore

The zoom state can be saved, restored and programmatically initialised and modified, using the [Chart State API](https://www.ag-grid.com/charts/archive/14.2.0/javascript/api-state/).

## API Reference

#### Zoom

| Property | Type | Default | Description |
| --- | --- | --- | --- |
| anchorPointX | 'pointer' \| 'start' \| 'middle' \| 'end' | end | The anchor point for the x-axis about which to zoom into when scrolling. |
| anchorPointY | 'pointer' \| 'start' \| 'middle' \| 'end' | middle | The anchor point for the y-axis about which to zoom into when scrolling. |
| autoScaling | AgZoomAutoScaling |  | Zoom auto scaling options. |
| autoScaling.enabled | boolean | true | Set to `false` to disable the auto scaling of the y-axis when zooming the x-axis. |
| autoScaling.padding | Ratio |  | Padding to apply between the zoomed data and the boundary of the series. |
| axes | 'x' \| 'y' \| 'xy' | x | The axes on which to zoom when scrolling, one of `xy`, `x`, or `y`. |
| axisDraggingMode | 'pan' \| 'zoom' | zoom | Whether dragging an axis pans or zooms, if `enableAxisDragging` is enabled. |
| buttons | AgZoomButtons |  | A set of buttons to perform common zoom actions. |
| buttons.buttons | AgZoomButton[] |  | The buttons to show. |
| buttons.buttons.value (required) | 'reset' \| 'zoom-in' \| 'zoom-out' \| 'pan-left' \| 'pan-right' \| 'pan-start' \| 'pan-end' |  | The action to perform when the button is clicked. |
| buttons.buttons.section (required) | string |  | The toolbar section in which to display this button. |
| buttons.buttons.icon | AgIconName |  | Icon to display on the button. |
| buttons.buttons.label | string |  | Text label to display on the button. |
| buttons.buttons.ariaLabel | string |  | Text label to announce in screen readers. |
| buttons.buttons.tooltip | string |  | Tooltip text to display on hover over the button. |
| buttons.visible | 'always' \| 'zoomed' \| 'hover' | 'hover' | When the buttons should be visible. |
| buttons.enabled | boolean |  | Whether the associated elements and properties should be used in the chart. |
| deceleration | 'off' \| 'short' \| 'long' \| Ratio | short | Rate of deceleration of panning when dragging and releasing a zoomed chart. |
| enabled | boolean | false | Set to `true` to enable the zoom module. |
| enableAxisDragging | boolean | true | Set to `true` to enable dragging an axis to zoom series attached to that axis. |
| enableAxisScrolling | boolean | true | Set to `true` to enable scrolling an axis to zoom series attached to that axis. |
| enableDoubleClickToReset | boolean | true | Set to `true` to enable double-clicking to reset the chart to fully zoomed out. |
| enablePanning | boolean | true | Set to `true` to enable panning while zoomed. |
| enableScrolling | boolean | true | Set to `true` to enable zooming with the mouse wheel. |
| enableSelecting | boolean | false | Set to `true` to enable selecting an area of the chart to zoom into. |
| enableTwoFingerZoom | boolean | true | Set to `true` to enable zoom-panning with two touch points. |
| keepAspectRatio | boolean | false | Set to `true` to keep the selection area matching the chart's aspect ratio. |
| minVisibleItems | number | 2 | The minimum number of items to be shown, beyond which zooming is stopped. Set to `0` to allow unlimited zooming. |
| panKey | 'alt' \| 'ctrl' \| 'meta' \| 'shift' | alt | The key that should be pressed to allow dragging to pan around while zoomed, one of `alt`, `ctrl`, `meta` or `shift`. |
| scrollingMode | 'pan' \| 'zoom' | zoom | Whether scrolling the mouse wheel or track pad vertically zooms or pans. |
| scrollingStep | Ratio | 0.1 | The amount to zoom when scrolling with the mouse wheel, as a ratio of the full chart. |
| onDataChange | AgZoomOnDataChange |  | Configuration for how the zoom-pan should respond to data changes |
| onDataChange.strategy | 'reset' \| 'preserveDomain' \| 'preserveRatios' | 'preserveDomain' | The behaviour of how to adjust the zoom when chart data changes. |
| onDataChange.stickToEnd | boolean | false | When `true`, the zoom will be adjusted to ensure that newly appended data is in the viewport. This behaviour only happens if the chart's horizontal viewport is panned all the way to the very end of data range; otherwise the current `strategy` is used instead. |

#### Data Source

| Property | Type | Default | Description |
| --- | --- | --- | --- |
| getData (required) | Function |  | Asynchronous callback to load data into the chart. |


---
product: "AG Charts"
title: "Zoom"
description: "Zoom into React charts to navigate large datasets; supports mouse scrolling, panning, selecting, and dragging or enable the navigator / context menu."
enterprise: true
framework: react
version: "14.2.0"
related:
    - title: "Accessibility"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/accessibility/"
    - title: "Localisation"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/localisation/"
    - title: "Series Highlighting"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/series-highlighting/"
    - title: "Tooltips"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/tooltips/"
    - title: "Touch"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/touch/"
    - title: "Animation"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/animation/"
    - title: "Context Menu"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/context-menu/"
    - title: "Crosshairs & Band Highlight"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/axes-crosshairs/"
    - title: "Data Selection"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/selection/"
    - title: "Flash On Update"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/flash-on-update/"
    - title: "Navigator"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/navigator/"
    - title: "Range Controls"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/range-controls/"
    - title: "Scrollbar"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/scrollbar/"
    - title: "Synchronization"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/sync/"
llms: "https://www.ag-grid.com/charts/archive/14.2.0/llms.txt"
---

# Zoom

AG Charts allows zooming into charts, making it easier to navigate large datasets.

#### Zoom

```tsx
import React, { useState } from "react";
import { createRoot } from "react-dom/client";
import { AgCharts } from "ag-charts-react";
import {
  AgCartesianChartOptions,
  AnimationModule,
  ContextMenuModule,
  CrosshairModule,
  LegendModule,
  LineSeriesModule,
  ModuleRegistry,
  NumberAxisModule,
  ZoomModule,
} from "ag-charts-enterprise";
import { getData } from "./data";

ModuleRegistry.registerModules([
  AnimationModule,
  CrosshairModule,
  LegendModule,
  LineSeriesModule,
  NumberAxisModule,
  ZoomModule,
  ContextMenuModule,
]);

const ChartExample = () => {
  const [options, setOptions] = useState<AgCartesianChartOptions>({
    zoom: {
      enabled: true,
    },
    tooltip: {
      enabled: false,
    },
    axes: {
      x: {
        type: "number",
        nice: false,
        interval: {
          minSpacing: 80,
          maxSpacing: 120,
        },
        label: {
          autoRotate: false,
        },
      },
    },
    data: getData(),
    series: [
      {
        type: "line",
        xKey: "year",
        yKey: "spending",
      },
    ],
  });

  return <AgCharts options={options} />;
};

const root = createRoot(document.getElementById("root")!);
root.render(<ChartExample />);
```

[Live example: Zoom](https://www.ag-grid.com/charts/archive/14.2.0/reactFunctionalTs/zoom/examples/zoom/)

To enable this feature, set `zoom.enabled` to `true`.

```js
{
    zoom: {
        enabled: true,
    },
}
```

In the above example you can:

- Scroll in and out with the mouse wheel or trackpad.
- Zoom and pan using [touch and multi-touch](https://www.ag-grid.com/charts/archive/14.2.0/react/touch/) functionality.
- Use `+` and `-` keys to zoom in or out (when in focus).
- Click and drag the mouse to pan around the zoomed in chart.
- Click (or touch) and drag an axis to zoom in or out on only that axis.
- Double click (or double tap) anywhere to reset the zoom.
- Double click (or double tap) an axis to reset the zoom on only that axis.

> **Note**
>
> If `axis[].tick.maxSpacing` is provided, the axis ticks and labels will update with the zoom.

## Scrolling

This allows zooming by using the mouse wheel or trackpad, as shown in the above example and is enabled by default. To disable, use `enableScrolling: false`.

### Anchor Point

By default, the chart will zoom while keeping the right side of the x-axis pinned. You can change this anchor point with the `anchorPointX` and `anchorPointY` properties, setting them each to one of:

- `start`, the left or bottom of the chart when scrolling on the x-axis or y-axis respectively,
- `middle` (default for y-axis), the middle of the chart,
- `end` (default for x-axis), the right or top of the chart when scrolling on the x-axis or y-axis respectively,
- `pointer`, keep the mouse pointer above the same position on the chart when zooming.

In the example below, we set the anchor point for both axes to the mouse pointer.

#### Zoom Anchor Point

```tsx
import React, { useState } from "react";
import { createRoot } from "react-dom/client";
import { AgCharts } from "ag-charts-react";
import {
  AgCartesianChartOptions,
  AnimationModule,
  CategoryAxisModule,
  ContextMenuModule,
  CrosshairModule,
  LegendModule,
  LineSeriesModule,
  ModuleRegistry,
  NumberAxisModule,
  ZoomModule,
} from "ag-charts-enterprise";
import { getData } from "./data";

ModuleRegistry.registerModules([
  AnimationModule,
  CategoryAxisModule,
  CrosshairModule,
  LegendModule,
  LineSeriesModule,
  NumberAxisModule,
  ZoomModule,
  ContextMenuModule,
]);

const ChartExample = () => {
  const [options, setOptions] = useState<AgCartesianChartOptions>({
    zoom: {
      enabled: true,
      axes: "xy",
      anchorPointX: "pointer",
      anchorPointY: "pointer",
    },
    tooltip: {
      enabled: false,
    },
    axes: {
      y: {
        type: "number",
        interval: {
          minSpacing: 80,
          maxSpacing: 120,
        },
      },
      x: {
        type: "number",
        nice: false,
        interval: {
          minSpacing: 80,
          maxSpacing: 120,
        },
        label: {
          autoRotate: false,
        },
      },
    },
    data: getData(),
    series: [
      {
        type: "line",
        xKey: "year",
        yKey: "spending",
      },
    ],
  });

  return <AgCharts options={options} />;
};

const root = createRoot(document.getElementById("root")!);
root.render(<ChartExample />);
```

[Live example: Zoom Anchor Point](https://www.ag-grid.com/charts/archive/14.2.0/reactFunctionalTs/zoom/examples/zoom-anchor-point/)

```js
{
    zoom: {
        anchorPointX: 'pointer',
        anchorPointY: 'pointer',
    },
}
```

### Scrolling Step

When scrolling, the chart zooms in by a single step for each movement of the scroll wheel or trackpad. By default `scrollingStep` is set to `0.1`, or 10% of the chart each time.

In the example below, we change the step to `0.4`.

#### Zoom Scrolling Step

```tsx
import React, { useState } from "react";
import { createRoot } from "react-dom/client";
import { AgCharts } from "ag-charts-react";
import {
  AgCartesianChartOptions,
  AnimationModule,
  ContextMenuModule,
  CrosshairModule,
  LegendModule,
  LineSeriesModule,
  ModuleRegistry,
  NumberAxisModule,
  ZoomModule,
} from "ag-charts-enterprise";
import { getData } from "./data";

ModuleRegistry.registerModules([
  AnimationModule,
  CrosshairModule,
  LegendModule,
  LineSeriesModule,
  NumberAxisModule,
  ZoomModule,
  ContextMenuModule,
]);

const ChartExample = () => {
  const [options, setOptions] = useState<AgCartesianChartOptions>({
    zoom: {
      enabled: true,
      scrollingStep: 0.4,
    },
    tooltip: {
      enabled: false,
    },
    axes: {
      y: {
        type: "number",
        interval: {
          minSpacing: 80,
          maxSpacing: 120,
        },
      },
      x: {
        type: "number",
        nice: false,
        interval: {
          minSpacing: 80,
          maxSpacing: 120,
        },
        label: {
          autoRotate: false,
        },
      },
    },
    data: getData(),
    series: [
      {
        type: "line",
        xKey: "year",
        yKey: "spending",
      },
    ],
  });

  return <AgCharts options={options} />;
};

const root = createRoot(document.getElementById("root")!);
root.render(<ChartExample />);
```

[Live example: Zoom Scrolling Step](https://www.ag-grid.com/charts/archive/14.2.0/reactFunctionalTs/zoom/examples/zoom-scrolling-step/)

```js
{
    zoom: {
        scrollingStep: 0.4,
    },
}
```

### Axes

By default, scrolling zoom is only enabled for the `x` axis. This can be changed by setting the `axes` property to `x`, `y` or `xy`.

In the example below, we enable zoom on both the `x` and `y` axes.

#### Zoom Axes

```tsx
import React, { useState } from "react";
import { createRoot } from "react-dom/client";
import { AgCharts } from "ag-charts-react";
import {
  AgCartesianChartOptions,
  AnimationModule,
  CategoryAxisModule,
  ContextMenuModule,
  CrosshairModule,
  LegendModule,
  LineSeriesModule,
  ModuleRegistry,
  NumberAxisModule,
  ZoomModule,
} from "ag-charts-enterprise";
import { getData } from "./data";

ModuleRegistry.registerModules([
  AnimationModule,
  CategoryAxisModule,
  CrosshairModule,
  LegendModule,
  LineSeriesModule,
  NumberAxisModule,
  ZoomModule,
  ContextMenuModule,
]);

const ChartExample = () => {
  const [options, setOptions] = useState<AgCartesianChartOptions>({
    zoom: {
      enabled: true,
      axes: "xy",
    },
    tooltip: {
      enabled: false,
    },
    axes: {
      y: {
        type: "number",
        interval: {
          minSpacing: 80,
          maxSpacing: 120,
        },
      },
      x: {
        type: "number",
        nice: false,
        interval: {
          minSpacing: 80,
          maxSpacing: 120,
        },
        label: {
          autoRotate: false,
        },
      },
    },
    data: getData(),
    series: [
      {
        type: "line",
        xKey: "year",
        yKey: "spending",
      },
    ],
  });

  return <AgCharts options={options} />;
};

const root = createRoot(document.getElementById("root")!);
root.render(<ChartExample />);
```

[Live example: Zoom Axes](https://www.ag-grid.com/charts/archive/14.2.0/reactFunctionalTs/zoom/examples/zoom-axes/)

```js
{
    zoom: {
        axes: 'xy',
    },
}
```

### Scrolling Mode

By default, vertical mouse wheel or trackpad scrolling zooms the chart. Set `scrollingMode: 'pan'` to pan instead.

#### Zoom Scrolling Mode

```tsx
import React, { useState, Fragment } from "react";
import { createRoot } from "react-dom/client";
import { AgCharts } from "ag-charts-react";
import {
  AgCartesianChartOptions,
  AnimationModule,
  BarSeriesModule,
  CategoryAxisModule,
  ContextMenuModule,
  ModuleRegistry,
  NumberAxisModule,
  ZoomModule,
} from "ag-charts-enterprise";
import { getData } from "./data";
import clone from "clone";

ModuleRegistry.registerModules([
  AnimationModule,
  BarSeriesModule,
  CategoryAxisModule,
  NumberAxisModule,
  ZoomModule,
  ContextMenuModule,
]);

const ChartExample = () => {
  const [options, setOptions] = useState<AgCartesianChartOptions>({
    zoom: {
      enabled: true,
      scrollingMode: "zoom",
    },
    title: {
      text: "Population by Country (millions)",
    },
    initialState: {
      zoom: {
        ratioY: { start: 0.6 },
      },
    },
    axes: {
      x: {
        type: "number",
        label: {
          formatter: (params) => `${params.value}M`,
        },
      },
    },
    data: getData(),
    series: [
      {
        type: "bar",
        direction: "horizontal",
        xKey: "country",
        yKey: "population",
        yName: "Population (millions)",
      },
    ],
  });

  const setScrollingMode = (event: Event) => {
    const nextOptions = clone(options);

    nextOptions.zoom!.scrollingMode = (event.target as HTMLInputElement)
      .value as "zoom" | "pan";

    setOptions(nextOptions);
  };

  return (
    <Fragment>
      <div className="example-controls">
        <div className="controls-row">
          <span>Scrolling Mode:</span>
          <div
            className="button-group"
            role="group"
            aria-label="Scrolling Mode"
          >
            <input
              type="radio"
              id="scrolling-zoom"
              name="scrolling-mode"
              defaultValue="zoom"
              defaultChecked
              onChange={(event) => setScrollingMode(event)}
            />
            <label htmlFor="scrolling-zoom">Zoom</label>
            <input
              type="radio"
              id="scrolling-pan"
              name="scrolling-mode"
              defaultValue="pan"
              onChange={(event) => setScrollingMode(event)}
            />
            <label htmlFor="scrolling-pan">Pan</label>
          </div>
        </div>
      </div>
      <AgCharts options={options} />
    </Fragment>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(<ChartExample />);
```

[Live example: Zoom Scrolling Mode](https://www.ag-grid.com/charts/archive/14.2.0/reactFunctionalTs/zoom/examples/zoom-scrolling-mode/)

```js
{
    zoom: {
        scrollingMode: 'pan',
    },
}
```

## Panning

This is enabled by default and allows users to click and drag to move around a zoomed chart. To disable, use `enablePanning: false`.

If [zoom by selecting](https://www.ag-grid.com/charts/archive/14.2.0/react/zoom/#selecting) is enabled, clicking and dragging will no longer pan by default. Instead the user will need to hold down a key to switch to panning mode.

This key defaults to `alt` but can be set with the `panKey` property to one of `alt`, `ctrl`, `shift` or `meta` (the command key on MacOS or start key on Windows).

In the example below, panning can only be done by holding down the `shift` key while clicking and dragging.

#### Zoom Pan Key

```tsx
import React, { useState } from "react";
import { createRoot } from "react-dom/client";
import { AgCharts } from "ag-charts-react";
import {
  AgCartesianChartOptions,
  AnimationModule,
  ContextMenuModule,
  CrosshairModule,
  LegendModule,
  LineSeriesModule,
  ModuleRegistry,
  NumberAxisModule,
  ZoomModule,
} from "ag-charts-enterprise";
import { getData } from "./data";

ModuleRegistry.registerModules([
  AnimationModule,
  CrosshairModule,
  LegendModule,
  LineSeriesModule,
  NumberAxisModule,
  ZoomModule,
  ContextMenuModule,
]);

const ChartExample = () => {
  const [options, setOptions] = useState<AgCartesianChartOptions>({
    zoom: {
      enabled: true,
      enableSelecting: true,
      panKey: "shift",
    },
    tooltip: {
      enabled: false,
    },
    axes: {
      y: {
        type: "number",
        interval: {
          minSpacing: 80,
          maxSpacing: 120,
        },
      },
      x: {
        type: "number",
        nice: false,
        interval: {
          minSpacing: 80,
          maxSpacing: 120,
        },
        label: {
          autoRotate: false,
        },
      },
    },
    data: getData(),
    series: [
      {
        type: "line",
        xKey: "year",
        yKey: "spending",
      },
    ],
  });

  return <AgCharts options={options} />;
};

const root = createRoot(document.getElementById("root")!);
root.render(<ChartExample />);
```

[Live example: Zoom Pan Key](https://www.ag-grid.com/charts/archive/14.2.0/reactFunctionalTs/zoom/examples/zoom-pan-key/)

```js
{
    zoom: {
        panKey: 'shift',
    },
}
```

## Selecting

This method of zooming works by clicking and dragging a box to select an area on the chart. This is disabled by default. To enable, use `enableSelecting: true`.

In the example below, the user can only zoom in by selection, and can only zoom out by double-click to reset.

#### Zoom Selecting

```tsx
import React, { useState } from "react";
import { createRoot } from "react-dom/client";
import { AgCharts } from "ag-charts-react";
import {
  AgCartesianChartOptions,
  AnimationModule,
  ContextMenuModule,
  CrosshairModule,
  LegendModule,
  LineSeriesModule,
  ModuleRegistry,
  NumberAxisModule,
  ZoomModule,
} from "ag-charts-enterprise";
import { getData } from "./data";

ModuleRegistry.registerModules([
  AnimationModule,
  CrosshairModule,
  LegendModule,
  LineSeriesModule,
  NumberAxisModule,
  ZoomModule,
  ContextMenuModule,
]);

const ChartExample = () => {
  const [options, setOptions] = useState<AgCartesianChartOptions>({
    zoom: {
      enableAxisDragging: false,
      enablePanning: false,
      enableScrolling: false,
      enableSelecting: true,
    },
    tooltip: {
      enabled: false,
    },
    axes: {
      y: {
        type: "number",
        interval: {
          minSpacing: 80,
          maxSpacing: 120,
        },
      },
      x: {
        type: "number",
        nice: false,
        interval: {
          minSpacing: 80,
          maxSpacing: 120,
        },
        label: {
          autoRotate: false,
        },
      },
    },
    data: getData(),
    series: [
      {
        type: "line",
        xKey: "year",
        yKey: "spending",
      },
    ],
  });

  return <AgCharts options={options} />;
};

const root = createRoot(document.getElementById("root")!);
root.render(<ChartExample />);
```

[Live example: Zoom Selecting](https://www.ag-grid.com/charts/archive/14.2.0/reactFunctionalTs/zoom/examples/zoom-selecting/)

```js
{
    zoom: {
        enableAxisDragging: false,
        enablePanning: false,
        enableScrolling: false,
        enableSelecting: true,
    },
}
```

## Two Finger Zoom-Pan

By default, using two fingers to pinch in or out will zoom the chart. It is also possible to use two fingers to pan a zoomed chart.

To disable this behaviour, use `enableTwoFingerZoom: false`.

#### Two Finger Zoom-Pan Disabled

```tsx
import React, { useState } from "react";
import { createRoot } from "react-dom/client";
import { AgCharts } from "ag-charts-react";
import {
  AgCartesianChartOptions,
  AnimationModule,
  ContextMenuModule,
  CrosshairModule,
  LegendModule,
  LineSeriesModule,
  ModuleRegistry,
  NumberAxisModule,
  ZoomModule,
} from "ag-charts-enterprise";
import { getData } from "./data";

ModuleRegistry.registerModules([
  AnimationModule,
  CrosshairModule,
  LegendModule,
  LineSeriesModule,
  NumberAxisModule,
  ZoomModule,
  ContextMenuModule,
]);

const ChartExample = () => {
  const [options, setOptions] = useState<AgCartesianChartOptions>({
    zoom: {
      enableTwoFingerZoom: false,
    },
    initialState: {
      zoom: {
        ratioX: { start: 0.48, end: 0.52 },
        ratioY: { start: 0.21, end: 0.82 },
      },
    },
    tooltip: {
      enabled: false,
    },
    axes: {
      y: {
        type: "number",
        interval: {
          minSpacing: 80,
          maxSpacing: 120,
        },
      },
      x: {
        type: "number",
        nice: false,
        interval: {
          minSpacing: 80,
          maxSpacing: 120,
        },
        label: {
          autoRotate: false,
        },
      },
    },
    data: getData(),
    series: [
      {
        type: "line",
        xKey: "year",
        yKey: "spending",
      },
    ],
  });

  return <AgCharts options={options} />;
};

const root = createRoot(document.getElementById("root")!);
root.render(<ChartExample />);
```

[Live example: Two Finger Zoom-Pan Disabled](https://www.ag-grid.com/charts/archive/14.2.0/reactFunctionalTs/zoom/examples/two-finger-disabled/)

```js
{
    zoom: {
        enableTwoFingerZoom: false,
    },
}
```

In the above example:

- Two fingers gestures are not consumed by the chart. Instead they zoom or scroll the entire page.

## Axis Zoom Controls

By default, a user can click and drag on any axis to change the zoom of that axis. This ignores the `axes` property and is enabled by default for all axes.

#### Axis Zoom Controls

```tsx
import React, { useState, Fragment } from "react";
import { createRoot } from "react-dom/client";
import { AgCharts } from "ag-charts-react";
import {
  AgCartesianChartOptions,
  AnimationModule,
  ContextMenuModule,
  CrosshairModule,
  LegendModule,
  LineSeriesModule,
  ModuleRegistry,
  NumberAxisModule,
  ZoomModule,
} from "ag-charts-enterprise";
import { getData } from "./data";
import clone from "clone";

ModuleRegistry.registerModules([
  AnimationModule,
  CrosshairModule,
  LegendModule,
  LineSeriesModule,
  NumberAxisModule,
  ZoomModule,
  ContextMenuModule,
]);

const ChartExample = () => {
  const [options, setOptions] = useState<AgCartesianChartOptions>({
    zoom: {
      enabled: true,
      enableAxisDragging: true,
      enableAxisScrolling: true,
      axisDraggingMode: "zoom",
    },
    tooltip: {
      enabled: false,
    },
    axes: {
      y: {
        type: "number",
        position: "left",
        title: {
          text: "Spending",
        },
        interval: {
          minSpacing: 80,
          maxSpacing: 120,
        },
      },
      ySecondary: {
        type: "number",
        position: "right",
        title: {
          text: "Tonnes",
        },
        interval: {
          minSpacing: 80,
          maxSpacing: 120,
        },
      },
      x: {
        type: "number",
        nice: false,
        interval: {
          minSpacing: 80,
          maxSpacing: 120,
        },
        label: {
          autoRotate: false,
        },
      },
    },
    data: getData(),
    series: [
      {
        type: "line",
        xKey: "year",
        yKey: "spending",
      },
      {
        type: "line",
        xKey: "year",
        yKey: "tonnes",
        yKeyAxis: "ySecondary",
      },
    ],
  });

  const setAxisDragging = (mode: "zoom" | "pan") => {
    const nextOptions = clone(options);

    nextOptions.zoom!.axisDraggingMode = mode;

    setOptions(nextOptions);
  };

  const enableAxisDragging = (enabled: "on" | "off") => {
    const nextOptions = clone(options);

    nextOptions.zoom!.enableAxisDragging = enabled === "on";

    setOptions(nextOptions);
  };

  const enableAxisScrolling = (enabled: "on" | "off") => {
    const nextOptions = clone(options);

    nextOptions.zoom!.enableAxisScrolling = enabled === "on";

    setOptions(nextOptions);
  };

  return (
    <Fragment>
      <div className="example-controls">
        <div className="controls-row">
          <label htmlFor="enable-dragging">Axis Dragging:</label>
          <select
            id="enable-dragging"
            onChange={(event) => enableAxisDragging(event.target.value)}
            className="gap-right"
          >
            <option value="on">Enabled</option>
            <option value="off">Disabled</option>
          </select>
          <label htmlFor="dragging-mode">Axis Dragging Mode:</label>
          <select
            id="dragging-mode"
            onChange={(event) => setAxisDragging(event.target.value)}
            className="gap-right"
          >
            <option value="zoom">Zoom</option>
            <option value="pan">Pan</option>
          </select>
          <label htmlFor="enable-scrolling">Axis Scrolling:</label>
          <select
            id="enable-scrolling"
            onChange={(event) => enableAxisScrolling(event.target.value)}
          >
            <option value="on">Enabled</option>
            <option value="off">Disabled</option>
          </select>
        </div>
      </div>
      <AgCharts options={options} />
    </Fragment>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(<ChartExample />);
```

[Live example: Axis Zoom Controls](https://www.ag-grid.com/charts/archive/14.2.0/reactFunctionalTs/zoom/examples/zoom-axis-controls/)

- When using `axisDraggingMode: 'zoom'` (default), dragging either of the y-axes will zoom both of them.
- Use `axisDraggingMode: 'pan'` to pan while dragging an axis.
- Use `enableAxisDragging: false` to disable all axis dragging.
- Scrolling on an axis to zoom is enabled by default. Use `enableAxisScrolling: false` to disable it.

## Double-Click to Reset

This allows users to reset the zoom by double-clicking in an empty space in the chart area, and is enabled by default. To disable, use `enableDoubleClickToReset: false`.

## Minimum Visible Items

The `minVisibleItems` option can be used to limit how far a user can zoom in to the chart.

The example below demonstrates setting `minVisibleItems` to `10`, preventing the user from zooming beyond showing a minimum of 10 points on the line.

#### Zoom Min Visible Items

```tsx
import React, { useState } from "react";
import { createRoot } from "react-dom/client";
import { AgCharts } from "ag-charts-react";
import {
  AgCartesianChartOptions,
  AnimationModule,
  ContextMenuModule,
  CrosshairModule,
  LegendModule,
  LineSeriesModule,
  ModuleRegistry,
  NumberAxisModule,
  ZoomModule,
} from "ag-charts-enterprise";
import { getData } from "./data";

ModuleRegistry.registerModules([
  AnimationModule,
  ContextMenuModule,
  CrosshairModule,
  LegendModule,
  LineSeriesModule,
  NumberAxisModule,
  ZoomModule,
]);

const ChartExample = () => {
  const [options, setOptions] = useState<AgCartesianChartOptions>({
    zoom: {
      minVisibleItems: 10,
    },
    tooltip: {
      enabled: false,
    },
    axes: {
      y: {
        type: "number",
        interval: {
          minSpacing: 80,
          maxSpacing: 120,
        },
      },
      x: {
        type: "number",
        nice: false,
        interval: {
          minSpacing: 80,
          maxSpacing: 120,
        },
        label: {
          autoRotate: false,
        },
      },
    },
    data: getData(),
    series: [
      {
        type: "line",
        xKey: "year",
        yKey: "spending",
      },
    ],
  });

  return <AgCharts options={options} />;
};

const root = createRoot(document.getElementById("root")!);
root.render(<ChartExample />);
```

[Live example: Zoom Min Visible Items](https://www.ag-grid.com/charts/archive/14.2.0/reactFunctionalTs/zoom/examples/zoom-min-visible-items/)

```js
{
    zoom: {
        minVisibleItems: 10,
    },
}
```

## Auto Scaling

Auto Scaling dynamically adjusts the y-axis to fit the visible data whenever the x-axis is zoomed or panned. This is enabled by default when zooming the x-axis. To disable, use `autoScaling: false`.

#### Auto Scaling

```tsx
import React, { useState, Fragment } from "react";
import { createRoot } from "react-dom/client";
import { AgCharts } from "ag-charts-react";
import {
  AgCartesianChartOptions,
  AnimationModule,
  CandlestickSeriesModule,
  ContextMenuModule,
  CrosshairModule,
  LegendModule,
  ModuleRegistry,
  NavigatorModule,
  NumberAxisModule,
  OrdinalTimeAxisModule,
  ZoomModule,
} from "ag-charts-enterprise";
import { getData } from "./data";
import clone from "clone";

ModuleRegistry.registerModules([
  AnimationModule,
  CandlestickSeriesModule,
  CrosshairModule,
  LegendModule,
  NavigatorModule,
  NumberAxisModule,
  OrdinalTimeAxisModule,
  ZoomModule,
  ContextMenuModule,
]);

const ChartExample = () => {
  const [options, setOptions] = useState<AgCartesianChartOptions>({
    data: getData(1e3),
    animation: { enabled: false },
    zoom: {
      enabled: true,
      anchorPointX: "pointer",
      anchorPointY: "pointer",
      autoScaling: {
        enabled: true,
      },
    },
    navigator: {
      enabled: true,
      miniChart: {
        enabled: true,
      },
    },
    series: [
      {
        type: "candlestick",
        xKey: "timestamp",
        lowKey: "low",
        highKey: "high",
        openKey: "open",
        closeKey: "close",
      },
    ],
  });

  const setAutoScaling = (event: Event) => {
    const nextOptions = clone(options);

    const autoScaling = (event.target as HTMLInputElement).value === "true";
    nextOptions.zoom!.autoScaling!.enabled = autoScaling;

    setOptions(nextOptions);
  };

  return (
    <Fragment>
      <div className="example-controls">
        <div className="controls-row">
          <div className="button-group" role="group" aria-label="Auto Scaling">
            <input
              type="radio"
              id="auto-scaling-disabled"
              name="auto-scaling"
              defaultValue="false"
              onChange={(event) => setAutoScaling(event)}
            />
            <label htmlFor="auto-scaling-disabled">Disabled</label>
            <input
              type="radio"
              id="auto-scaling-enabled"
              name="auto-scaling"
              defaultValue="true"
              defaultChecked
              onChange={(event) => setAutoScaling(event)}
            />
            <label htmlFor="auto-scaling-enabled">Enabled</label>
          </div>
        </div>
      </div>
      <AgCharts options={options} />
    </Fragment>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(<ChartExample />);
```

[Live example: Auto Scaling](https://www.ag-grid.com/charts/archive/14.2.0/reactFunctionalTs/zoom/examples/auto-scaling/)

```js
{
    zoom: {
        autoScaling: {
            enabled: false,
        },
    },
}
```

In the above example:

- Zoom in to the chart by scrolling and then pan left and right.
- Observe how the vertical axis domain changes to fit the displayed data range.

Auto Scaling is never applied when the user has manually adjusted the y-axis by dragging it. Auto Scaling will be reapplied when the y-axis is reset, for example by double clicking on it.

## On Data Change

When data is updated while the chart is zoomed, the `zoom.onDataChange` options control how the zoomed view adjusts. This helps users maintain their focus when data changes, or always see the latest data.

The default strategy is `preserveDomain`, use `onDataChange.strategy` to change to one of the below.

### Preserve Domain

`strategy: 'preserveDomain'` preserves the current axis domain when data changes, keeping the view at the exact domain values if possible.

This is useful for appending data without disrupting users viewing a specific time period in the middle of the data.

#### Preserve Domain

```tsx
import React, { useState, useRef, Fragment } from "react";
import { createRoot } from "react-dom/client";
import { AgCharts } from "ag-charts-react";
import {
  AgCartesianChartOptions,
  AgChartsInstance,
  LineSeriesModule,
  ModuleRegistry,
  NavigatorModule,
  NumberAxisModule,
  TimeAxisModule,
  ZoomModule,
} from "ag-charts-enterprise";
import { getData, getNextDataPoint } from "./data";
import clone from "clone";

let data = getData();
let streamingInterval: ReturnType<typeof setInterval> | null = null;
ModuleRegistry.registerModules([
  LineSeriesModule,
  NavigatorModule,
  NumberAxisModule,
  TimeAxisModule,
  ZoomModule,
]);

const ChartExample = () => {
  const chartRef = useRef<AgChartsInstance>(null);
  const [options, setOptions] = useState<AgCartesianChartOptions>({
    data,
    series: [
      {
        type: "line",
        xKey: "date",
        yKey: "price",
        marker: { enabled: false },
      },
    ],
    axes: {
      x: {
        type: "time",
        nice: false,
      },
      y: {
        type: "number",
        title: { text: "Price" },
      },
    },
    zoom: {
      enabled: true,
      onDataChange: {
        strategy: "preserveDomain",
      },
    },
    navigator: {
      enabled: true,
      miniChart: {
        enabled: true,
      },
    },
    initialState: {
      zoom: {
        ratioX: { start: 0.3, end: 0.7 },
      },
    },
  });

  const startUpdates = () => {
    if (streamingInterval) return;
    streamingInterval = setInterval(() => {
      const nextPoint = getNextDataPoint(data);
      data.push(nextPoint);
      chartRef.current!.applyTransaction({ add: [nextPoint] });
    }, 100);
  };

  const stopUpdates = () => {
    if (streamingInterval) {
      clearInterval(streamingInterval);
      streamingInterval = null;
    }
  };

  const resetData = () => {
    const nextOptions = clone(options);

    stopUpdates();
    data = getData();
    nextOptions.data = data;

    setOptions(nextOptions);
  };

  return (
    <Fragment>
      <div className="example-controls">
        <div className="controls-row">
          <button onClick={startUpdates}>Start Updates</button>
          <button onClick={stopUpdates}>Stop Updates</button>
          <button onClick={resetData}>Reset</button>
        </div>
      </div>
      <AgCharts ref={chartRef} options={options} />
    </Fragment>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(<ChartExample />);
```

[Live example: Preserve Domain](https://www.ag-grid.com/charts/archive/14.2.0/reactFunctionalTs/zoom/examples/on-data-change-preserve-domain/)

```js
{
    zoom: {
        enabled: true,
        onDataChange: {
            strategy: 'preserveDomain',
        },
    },
}
```

In this example:

- The chart is initially zoomed to the middle of the data.
- Start the updates to see new data appended at the end.
- Notice in the Navigator that new data has been added, but the chart view remains fixed on the same time range.

### Preserve Ratios

`strategy: 'preserveRatios'`, preserves the same zoom percentages regardless of data changes.

This is useful for maintaining a consistent proportional view of your data, with more data points becoming visible as the dataset grows.

#### Preserve Ratios

```tsx
import React, { useState, useRef, Fragment } from "react";
import { createRoot } from "react-dom/client";
import { AgCharts } from "ag-charts-react";
import {
  AgCartesianChartOptions,
  AgChartsInstance,
  LineSeriesModule,
  ModuleRegistry,
  NavigatorModule,
  NumberAxisModule,
  TimeAxisModule,
  ZoomModule,
} from "ag-charts-enterprise";
import { getData, getNextDataPoint } from "./data";
import clone from "clone";

let data = getData();
let streamingInterval: ReturnType<typeof setInterval> | null = null;
ModuleRegistry.registerModules([
  LineSeriesModule,
  NavigatorModule,
  NumberAxisModule,
  TimeAxisModule,
  ZoomModule,
]);

const ChartExample = () => {
  const chartRef = useRef<AgChartsInstance>(null);
  const [options, setOptions] = useState<AgCartesianChartOptions>({
    data,
    series: [
      {
        type: "line",
        xKey: "date",
        yKey: "price",
        marker: { enabled: false },
      },
    ],
    axes: {
      x: {
        type: "time",
        nice: false,
      },
      y: {
        type: "number",
        title: { text: "Price" },
      },
    },
    zoom: {
      enabled: true,
      onDataChange: {
        strategy: "preserveRatios",
      },
    },
    navigator: {
      enabled: true,
      miniChart: {
        enabled: true,
      },
    },
    initialState: {
      zoom: {
        ratioX: { start: 0.8, end: 1 },
      },
    },
  });

  const startUpdates = () => {
    if (streamingInterval) return;
    streamingInterval = setInterval(() => {
      const newPoints = [];
      for (let i = 0; i < 10; i++) {
        const nextPoint = getNextDataPoint(data);
        data.push(nextPoint);
        newPoints.push(nextPoint);
      }
      chartRef.current!.applyTransaction({ add: newPoints });
    }, 200);
  };

  const stopUpdates = () => {
    if (streamingInterval) {
      clearInterval(streamingInterval);
      streamingInterval = null;
    }
  };

  const resetData = () => {
    const nextOptions = clone(options);

    stopUpdates();
    data = getData();
    nextOptions.data = data;

    setOptions(nextOptions);
  };

  return (
    <Fragment>
      <div className="example-controls">
        <div className="controls-row">
          <button onClick={startUpdates}>Start Updates</button>
          <button onClick={stopUpdates}>Stop Updates</button>
          <button onClick={resetData}>Reset</button>
        </div>
      </div>
      <AgCharts ref={chartRef} options={options} />
    </Fragment>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(<ChartExample />);
```

[Live example: Preserve Ratios](https://www.ag-grid.com/charts/archive/14.2.0/reactFunctionalTs/zoom/examples/on-data-change-preserve-ratio/)

```js
{
    zoom: {
        enabled: true,
        onDataChange: {
            strategy: 'preserveRatios',
        },
    },
}
```

In this example:

- The chart is initially zoomed to the last 20% of the data.
- Start the updates to see new data points added in batches.
- Notice that more data points become visible in the chart view as total data grows, since the zoom ratio stays at 80%-100%.

### Reset

`strategy: 'reset'`, resets the zoom to the `initialState` or no zoom, whenever the data changes.

This is useful for switching between unrelated datasets, discarding previous user interactions and reverting to a predefined starting view.

#### Reset

```tsx
import React, { useState, Fragment } from "react";
import { createRoot } from "react-dom/client";
import { AgCharts } from "ag-charts-react";
import {
  AgCartesianChartOptions,
  LineSeriesModule,
  ModuleRegistry,
  NavigatorModule,
  NumberAxisModule,
  TimeAxisModule,
  ZoomModule,
} from "ag-charts-enterprise";
import { getDatasetA, getDatasetB } from "./data";
import clone from "clone";

ModuleRegistry.registerModules([
  LineSeriesModule,
  NavigatorModule,
  NumberAxisModule,
  TimeAxisModule,
  ZoomModule,
]);

const ChartExample = () => {
  const [options, setOptions] = useState<AgCartesianChartOptions>({
    data: getDatasetA(),
    series: [
      {
        type: "line",
        xKey: "date",
        yKey: "price",
        marker: { enabled: false },
      },
    ],
    axes: {
      x: {
        type: "time",
        nice: false,
      },
      y: {
        type: "number",
        title: { text: "Price" },
      },
    },
    zoom: {
      enabled: true,
      onDataChange: {
        strategy: "reset",
      },
    },
    navigator: {
      enabled: true,
      miniChart: {
        enabled: true,
      },
    },
    initialState: {
      zoom: {
        ratioX: { start: 0.9, end: 1 },
      },
    },
  });

  const loadDatasetA = () => {
    const nextOptions = clone(options);

    nextOptions.data = getDatasetA();

    setOptions(nextOptions);
  };

  const loadDatasetB = () => {
    const nextOptions = clone(options);

    nextOptions.data = getDatasetB();

    setOptions(nextOptions);
  };

  return (
    <Fragment>
      <div className="example-controls">
        <div className="controls-row">
          <button onClick={loadDatasetA}>Load Dataset A</button>
          <button onClick={loadDatasetB}>Load Dataset B</button>
        </div>
      </div>
      <AgCharts options={options} />
    </Fragment>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(<ChartExample />);
```

[Live example: Reset](https://www.ag-grid.com/charts/archive/14.2.0/reactFunctionalTs/zoom/examples/on-data-change-reset/)

```js
{
    zoom: {
        enabled: true,
        onDataChange: {
            strategy: 'reset',
        },
    },
}
```

In this example:

- The chart is initially zoomed to show only the last few data points.
- Pan or zoom to a different position in the chart.
- Click a button to switch datasets and notice that the zoom resets to the initial state.

### Stick to End

The `stickToEnd` option automatically scrolls to keep the latest data visible when new data is appended and the view is already at the end of the data range. Use `stickToEnd: true` to enable.

When `stickToEnd` is active, it takes precedence over the configured strategy. Once the user pans away from the end, the configured strategy (e.g., `preserveDomain`) takes over until they return to viewing the end.

#### Stick to End

```tsx
import React, { useState, useRef, Fragment } from "react";
import { createRoot } from "react-dom/client";
import { AgCharts } from "ag-charts-react";
import {
  AgCartesianChartOptions,
  AgChartsInstance,
  LineSeriesModule,
  ModuleRegistry,
  NavigatorModule,
  NumberAxisModule,
  TimeAxisModule,
  ZoomModule,
} from "ag-charts-enterprise";
import { getData, getNextDataPoint } from "./data";
import clone from "clone";

let data = getData();
let streamingInterval: ReturnType<typeof setInterval> | null = null;
ModuleRegistry.registerModules([
  LineSeriesModule,
  NavigatorModule,
  NumberAxisModule,
  TimeAxisModule,
  ZoomModule,
]);

const ChartExample = () => {
  const chartRef = useRef<AgChartsInstance>(null);
  const [options, setOptions] = useState<AgCartesianChartOptions>({
    data,
    series: [
      {
        type: "line",
        xKey: "date",
        yKey: "price",
        marker: { enabled: false },
      },
    ],
    axes: {
      x: {
        type: "time",
        nice: false,
      },
      y: {
        type: "number",
        title: { text: "Price" },
      },
    },
    zoom: {
      enabled: true,
      onDataChange: {
        strategy: "preserveDomain",
        stickToEnd: true,
      },
    },
    navigator: {
      enabled: true,
      miniChart: {
        enabled: true,
      },
    },
    initialState: {
      zoom: {
        ratioX: { start: 0.6, end: 1 },
      },
    },
  });

  const startUpdates = () => {
    if (streamingInterval) return;
    streamingInterval = setInterval(() => {
      const nextPoint = getNextDataPoint(data);
      data.push(nextPoint);
      chartRef.current!.applyTransaction({ add: [nextPoint] });
    }, 100);
  };

  const stopUpdates = () => {
    if (streamingInterval) {
      clearInterval(streamingInterval);
      streamingInterval = null;
    }
  };

  const resetData = () => {
    const nextOptions = clone(options);

    stopUpdates();
    data = getData();
    nextOptions.data = data;

    setOptions(nextOptions);
  };

  return (
    <Fragment>
      <div className="example-controls">
        <div className="controls-row">
          <button onClick={startUpdates}>Start Updates</button>
          <button onClick={stopUpdates}>Stop Updates</button>
          <button onClick={resetData}>Reset</button>
        </div>
      </div>
      <AgCharts ref={chartRef} options={options} />
    </Fragment>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(<ChartExample />);
```

[Live example: Stick to End](https://www.ag-grid.com/charts/archive/14.2.0/reactFunctionalTs/zoom/examples/on-data-change-stick-to-end/)

```js
{
    zoom: {
        enabled: true,
        onDataChange: {
            strategy: 'preserveDomain',
            stickToEnd: true,
        },
    },
}
```

In this example:

- The chart is initially zoomed to the end of the data.
- Start the updates to see new data appended and the view scrolls to follow.
- Pan away from the end to see the `preserveDomain` strategy take over with a fixed view.
- Pan back to the end and the view will resume following new data.

## Navigator

The zoom functionality can be used together with the [Navigator](https://www.ag-grid.com/charts/archive/14.2.0/react/navigator/) to add a visual reference to the zoom position.

## Context Menu

When both the zoom and [Context Menu](https://www.ag-grid.com/charts/archive/14.2.0/react/context-menu/) are enabled, additional zoom actions are added into the Context Menu for zooming and panning to the clicked location.

#### Zoom Context Menu

```tsx
import React, { useState } from "react";
import { createRoot } from "react-dom/client";
import { AgCharts } from "ag-charts-react";
import {
  AgCartesianChartOptions,
  AnimationModule,
  ContextMenuModule,
  CrosshairModule,
  LegendModule,
  LineSeriesModule,
  ModuleRegistry,
  NumberAxisModule,
  ZoomModule,
} from "ag-charts-enterprise";
import { getData } from "./data";

ModuleRegistry.registerModules([
  AnimationModule,
  ContextMenuModule,
  CrosshairModule,
  LegendModule,
  LineSeriesModule,
  NumberAxisModule,
  ZoomModule,
]);

const ChartExample = () => {
  const [options, setOptions] = useState<AgCartesianChartOptions>({
    zoom: {
      enabled: true,
    },
    contextMenu: {
      enabled: true,
    },
    tooltip: {
      enabled: false,
    },
    axes: {
      y: {
        type: "number",
        interval: {
          minSpacing: 80,
          maxSpacing: 120,
        },
      },
      x: {
        type: "number",
        nice: false,
        interval: {
          minSpacing: 80,
          maxSpacing: 120,
        },
        label: {
          autoRotate: false,
        },
      },
    },
    data: getData(),
    series: [
      {
        type: "line",
        xKey: "year",
        yKey: "spending",
      },
    ],
  });

  return <AgCharts options={options} />;
};

const root = createRoot(document.getElementById("root")!);
root.render(<ChartExample />);
```

[Live example: Zoom Context Menu](https://www.ag-grid.com/charts/archive/14.2.0/reactFunctionalTs/zoom/examples/zoom-context-menu/)

## Buttons

Zoom buttons are enabled by default. To disable, use `zoom.buttons.enabled: false`.

#### Zoom Buttons

```tsx
import React, { useState, Fragment } from "react";
import { createRoot } from "react-dom/client";
import { AgCharts } from "ag-charts-react";
import {
  AgCartesianChartOptions,
  AgZoomButtonsVisible,
  AnimationModule,
  ContextMenuModule,
  CrosshairModule,
  LegendModule,
  LineSeriesModule,
  ModuleRegistry,
  NumberAxisModule,
  UnitTimeAxisModule,
  ZoomModule,
} from "ag-charts-enterprise";
import { getData } from "./data";
import clone from "clone";

ModuleRegistry.registerModules([
  AnimationModule,
  CrosshairModule,
  LegendModule,
  LineSeriesModule,
  NumberAxisModule,
  UnitTimeAxisModule,
  ZoomModule,
  ContextMenuModule,
]);

const ChartExample = () => {
  const [options, setOptions] = useState<AgCartesianChartOptions>({
    zoom: {
      enabled: true,
      buttons: {
        visible: "hover",
      },
    },
    tooltip: {
      enabled: false,
    },
    axes: {
      x: {
        type: "unit-time",
        interval: {
          minSpacing: 50,
          maxSpacing: 200,
        },
        label: {
          autoRotate: false,
        },
        crosshair: {
          label: {
            format: `%d %b %Y`,
          },
        },
      },
    },
    data: getData(),
    series: [
      {
        type: "line",
        xKey: "time",
        yKey: "price",
      },
    ],
  });

  const changeVisible = (event: Event) => {
    const nextOptions = clone(options);

    nextOptions.zoom!.buttons!.visible = (event.target as HTMLInputElement)
      .value as AgZoomButtonsVisible;

    setOptions(nextOptions);
  };

  return (
    <Fragment>
      <div className="example-controls">
        <div className="controls-row">
          <span>Visible:</span>
          <div className="button-group" role="group" aria-label="Visible">
            <input
              type="radio"
              id="visible-always"
              name="visible"
              defaultValue="always"
              onChange={(event) => changeVisible(event)}
            />
            <label htmlFor="visible-always">Always</label>
            <input
              type="radio"
              id="visible-zoomed"
              name="visible"
              defaultValue="zoomed"
              onChange={(event) => changeVisible(event)}
            />
            <label htmlFor="visible-zoomed">Zoomed</label>
            <input
              type="radio"
              id="visible-hover"
              name="visible"
              defaultValue="hover"
              defaultChecked
              onChange={(event) => changeVisible(event)}
            />
            <label htmlFor="visible-hover">Hover Region</label>
          </div>
        </div>
      </div>
      <AgCharts options={options} />
    </Fragment>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(<ChartExample />);
```

[Live example: Zoom Buttons](https://www.ag-grid.com/charts/archive/14.2.0/reactFunctionalTs/zoom/examples/zoom-buttons/)

Hover near the bottom of the above example to see the default zoom buttons.

- **Zoom out**: Zooms the chart out by one [step](https://www.ag-grid.com/charts/archive/14.2.0/react/zoom/#scrolling-step).
- **Zoom in**: Zooms the chart in by one [step](https://www.ag-grid.com/charts/archive/14.2.0/react/zoom/#scrolling-step).
- **Pan left**: Pans the chart to the left by one [step](https://www.ag-grid.com/charts/archive/14.2.0/react/zoom/#scrolling-step).
- **Pan right**: Pans the chart to the right by one [step](https://www.ag-grid.com/charts/archive/14.2.0/react/zoom/#scrolling-step).
- **Reset**: Resets the zoom to the original level and position. Equivalent to [Double-Click to Reset](https://www.ag-grid.com/charts/archive/14.2.0/react/zoom/#double-click-to-reset).

To change when the buttons will appear, use `zoom.buttons.visible`:

- `always` – The buttons will always be visible.
- `zoomed` – The buttons will appear when the chart has been zoomed.
- `hover` – The buttons will appear when the mouse is hovered near the bottom of a chart which has zoom enabled.

### Customisation

It is possible to customise the visibility, order and grouping of buttons, as well as modifying the icon, label text and tooltip for each.

#### Customised Zoom Buttons

```tsx
import React, { useState } from "react";
import { createRoot } from "react-dom/client";
import { AgCharts } from "ag-charts-react";
import {
  AgCartesianChartOptions,
  AnimationModule,
  ContextMenuModule,
  CrosshairModule,
  LegendModule,
  LineSeriesModule,
  ModuleRegistry,
  NumberAxisModule,
  UnitTimeAxisModule,
  ZoomModule,
} from "ag-charts-enterprise";
import { getData } from "./data";

ModuleRegistry.registerModules([
  AnimationModule,
  CrosshairModule,
  LegendModule,
  LineSeriesModule,
  NumberAxisModule,
  UnitTimeAxisModule,
  ZoomModule,
  ContextMenuModule,
]);

const ChartExample = () => {
  const [options, setOptions] = useState<AgCartesianChartOptions>({
    zoom: {
      enabled: true,
      buttons: {
        visible: "always",
        buttons: [
          {
            icon: "zoom-in",
            tooltip: "Decrease Visible Range",
            value: "zoom-in",
            label: "In",
            section: "zoom",
          },
          {
            icon: "zoom-out",
            tooltip: "Increase Visible Range",
            value: "zoom-out",
            label: "Out",
            section: "zoom",
          },
          {
            icon: "pan-start",
            tooltip: "Pan to Start",
            value: "pan-start",
            section: "pan",
          },
          {
            icon: "pan-end",
            tooltip: "Pan to End",
            value: "pan-end",
            section: "pan",
          },
          {
            tooltip: "Undo all Zoom",
            value: "reset",
            label: "Reset",
            section: "reset",
          },
        ],
      },
    },
    tooltip: {
      enabled: false,
    },
    axes: {
      x: {
        type: "unit-time",
        interval: {
          minSpacing: 50,
          maxSpacing: 200,
        },
        label: {
          autoRotate: false,
        },
        crosshair: {
          label: {
            format: `%d %b %Y`,
          },
        },
      },
    },
    data: getData(),
    series: [
      {
        type: "line",
        xKey: "time",
        yKey: "price",
      },
    ],
  });

  return <AgCharts options={options} />;
};

const root = createRoot(document.getElementById("root")!);
root.render(<ChartExample />);
```

[Live example: Customised Zoom Buttons](https://www.ag-grid.com/charts/archive/14.2.0/reactFunctionalTs/zoom/examples/zoom-custom-buttons/)

```js
{
    zoom: {
        buttons: {
            visible: 'always',
            buttons: [
                {
                    icon: 'zoom-in',
                    tooltip: 'Decrease Visible Range',
                    value: 'zoom-in',
                    label: 'In',
                    section: 'zoom',
                },
                {
                    icon: 'zoom-out',
                    tooltip: 'Increase Visible Range',
                    value: 'zoom-out',
                    label: 'Out',
                    section: 'zoom',
                },
                {
                    icon: 'pan-start',
                    tooltip: 'Pan to Start',
                    value: 'pan-start',
                    section: 'pan',
                },
                {
                    icon: 'pan-end',
                    tooltip: 'Pan to End',
                    value: 'pan-end',
                    section: 'pan',
                },
                {
                    tooltip: 'Undo all Zoom',
                    value: 'reset',
                    label: 'Reset',
                    section: 'reset',
                },
            ],
        },
    },
}
```

In the above example:

- The pan-left and pan-right buttons are not shown.
- Additional buttons are added to enable panning to the start and end of the x-axis.
- All the buttons have custom tooltip text.
- The order of the zoom-in and zoom-out buttons is swapped and they have a label as well as an icon.
- The reset button has only a label and no icon.

For more information see the [API Reference section](https://www.ag-grid.com/charts/archive/14.2.0/react/zoom/#reference-AgZoomOptions-buttons-buttons).

## Asynchronous Loading

For loading data asynchronously as the user zooms and pans, see [Asynchronous Data](https://www.ag-grid.com/charts/archive/14.2.0/react/async-data/).

## Save & Restore

The zoom state can be saved, restored and programmatically initialised and modified, using the [Chart State API](https://www.ag-grid.com/charts/archive/14.2.0/react/api-state/).

## API Reference

#### Zoom

| Property | Type | Default | Description |
| --- | --- | --- | --- |
| anchorPointX | 'pointer' \| 'start' \| 'middle' \| 'end' | end | The anchor point for the x-axis about which to zoom into when scrolling. |
| anchorPointY | 'pointer' \| 'start' \| 'middle' \| 'end' | middle | The anchor point for the y-axis about which to zoom into when scrolling. |
| autoScaling | AgZoomAutoScaling |  | Zoom auto scaling options. |
| autoScaling.enabled | boolean | true | Set to `false` to disable the auto scaling of the y-axis when zooming the x-axis. |
| autoScaling.padding | Ratio |  | Padding to apply between the zoomed data and the boundary of the series. |
| axes | 'x' \| 'y' \| 'xy' | x | The axes on which to zoom when scrolling, one of `xy`, `x`, or `y`. |
| axisDraggingMode | 'pan' \| 'zoom' | zoom | Whether dragging an axis pans or zooms, if `enableAxisDragging` is enabled. |
| buttons | AgZoomButtons |  | A set of buttons to perform common zoom actions. |
| buttons.buttons | AgZoomButton[] |  | The buttons to show. |
| buttons.buttons.value (required) | 'reset' \| 'zoom-in' \| 'zoom-out' \| 'pan-left' \| 'pan-right' \| 'pan-start' \| 'pan-end' |  | The action to perform when the button is clicked. |
| buttons.buttons.section (required) | string |  | The toolbar section in which to display this button. |
| buttons.buttons.icon | AgIconName |  | Icon to display on the button. |
| buttons.buttons.label | string |  | Text label to display on the button. |
| buttons.buttons.ariaLabel | string |  | Text label to announce in screen readers. |
| buttons.buttons.tooltip | string |  | Tooltip text to display on hover over the button. |
| buttons.visible | 'always' \| 'zoomed' \| 'hover' | 'hover' | When the buttons should be visible. |
| buttons.enabled | boolean |  | Whether the associated elements and properties should be used in the chart. |
| deceleration | 'off' \| 'short' \| 'long' \| Ratio | short | Rate of deceleration of panning when dragging and releasing a zoomed chart. |
| enabled | boolean | false | Set to `true` to enable the zoom module. |
| enableAxisDragging | boolean | true | Set to `true` to enable dragging an axis to zoom series attached to that axis. |
| enableAxisScrolling | boolean | true | Set to `true` to enable scrolling an axis to zoom series attached to that axis. |
| enableDoubleClickToReset | boolean | true | Set to `true` to enable double-clicking to reset the chart to fully zoomed out. |
| enablePanning | boolean | true | Set to `true` to enable panning while zoomed. |
| enableScrolling | boolean | true | Set to `true` to enable zooming with the mouse wheel. |
| enableSelecting | boolean | false | Set to `true` to enable selecting an area of the chart to zoom into. |
| enableTwoFingerZoom | boolean | true | Set to `true` to enable zoom-panning with two touch points. |
| keepAspectRatio | boolean | false | Set to `true` to keep the selection area matching the chart's aspect ratio. |
| minVisibleItems | number | 2 | The minimum number of items to be shown, beyond which zooming is stopped. Set to `0` to allow unlimited zooming. |
| panKey | 'alt' \| 'ctrl' \| 'meta' \| 'shift' | alt | The key that should be pressed to allow dragging to pan around while zoomed, one of `alt`, `ctrl`, `meta` or `shift`. |
| scrollingMode | 'pan' \| 'zoom' | zoom | Whether scrolling the mouse wheel or track pad vertically zooms or pans. |
| scrollingStep | Ratio | 0.1 | The amount to zoom when scrolling with the mouse wheel, as a ratio of the full chart. |
| onDataChange | AgZoomOnDataChange |  | Configuration for how the zoom-pan should respond to data changes |
| onDataChange.strategy | 'reset' \| 'preserveDomain' \| 'preserveRatios' | 'preserveDomain' | The behaviour of how to adjust the zoom when chart data changes. |
| onDataChange.stickToEnd | boolean | false | When `true`, the zoom will be adjusted to ensure that newly appended data is in the viewport. This behaviour only happens if the chart's horizontal viewport is panned all the way to the very end of data range; otherwise the current `strategy` is used instead. |

#### Data Source

| Property | Type | Default | Description |
| --- | --- | --- | --- |
| getData (required) | Function |  | Asynchronous callback to load data into the chart. |


---
product: "AG Charts"
title: "Zoom"
description: "Zoom into Vue charts to navigate large datasets; supports mouse scrolling, panning, selecting, and dragging or enable the navigator / context menu."
enterprise: true
framework: vue
version: "14.2.0"
related:
    - title: "Accessibility"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/accessibility/"
    - title: "Localisation"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/localisation/"
    - title: "Series Highlighting"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/series-highlighting/"
    - title: "Tooltips"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/tooltips/"
    - title: "Touch"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/touch/"
    - title: "Animation"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/animation/"
    - title: "Context Menu"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/context-menu/"
    - title: "Crosshairs & Band Highlight"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/axes-crosshairs/"
    - title: "Data Selection"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/selection/"
    - title: "Flash On Update"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/flash-on-update/"
    - title: "Navigator"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/navigator/"
    - title: "Range Controls"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/range-controls/"
    - title: "Scrollbar"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/scrollbar/"
    - title: "Synchronization"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/sync/"
llms: "https://www.ag-grid.com/charts/archive/14.2.0/llms.txt"
---

# Zoom

AG Charts allows zooming into charts, making it easier to navigate large datasets.

#### Zoom

```ts
import { createApp, defineComponent, ref } from "vue";
import { AgCharts } from "ag-charts-vue3";
import type { AgChartOptions } from "ag-charts-types";
import {
  AnimationModule,
  ContextMenuModule,
  CrosshairModule,
  LegendModule,
  LineSeriesModule,
  ModuleRegistry,
  NumberAxisModule,
  ZoomModule,
} from "ag-charts-enterprise";
import { getData } from "./data";

ModuleRegistry.registerModules([
  AnimationModule,
  CrosshairModule,
  LegendModule,
  LineSeriesModule,
  NumberAxisModule,
  ZoomModule,
  ContextMenuModule,
]);

const ChartExample = defineComponent({
  template: `
    <ag-charts
      :options="options"
    />
  `,
  components: {
    "ag-charts": AgCharts,
  },
  setup(props) {
    const options = ref<AgCartesianChartOptions>({
      zoom: {
        enabled: true,
      },
      tooltip: {
        enabled: false,
      },
      axes: {
        x: {
          type: "number",
          nice: false,
          interval: {
            minSpacing: 80,
            maxSpacing: 120,
          },
          label: {
            autoRotate: false,
          },
        },
      },
      data: getData(),
      series: [
        {
          type: "line",
          xKey: "year",
          yKey: "spending",
        },
      ],
    });

    return {
      options,
    };
  },
});

createApp(ChartExample).mount("#app");
```

[Live example: Zoom](https://www.ag-grid.com/charts/archive/14.2.0/vue3/zoom/examples/zoom/)

To enable this feature, set `zoom.enabled` to `true`.

```js
{
    zoom: {
        enabled: true,
    },
}
```

In the above example you can:

- Scroll in and out with the mouse wheel or trackpad.
- Zoom and pan using [touch and multi-touch](https://www.ag-grid.com/charts/archive/14.2.0/vue/touch/) functionality.
- Use `+` and `-` keys to zoom in or out (when in focus).
- Click and drag the mouse to pan around the zoomed in chart.
- Click (or touch) and drag an axis to zoom in or out on only that axis.
- Double click (or double tap) anywhere to reset the zoom.
- Double click (or double tap) an axis to reset the zoom on only that axis.

> **Note**
>
> If `axis[].tick.maxSpacing` is provided, the axis ticks and labels will update with the zoom.

## Scrolling

This allows zooming by using the mouse wheel or trackpad, as shown in the above example and is enabled by default. To disable, use `enableScrolling: false`.

### Anchor Point

By default, the chart will zoom while keeping the right side of the x-axis pinned. You can change this anchor point with the `anchorPointX` and `anchorPointY` properties, setting them each to one of:

- `start`, the left or bottom of the chart when scrolling on the x-axis or y-axis respectively,
- `middle` (default for y-axis), the middle of the chart,
- `end` (default for x-axis), the right or top of the chart when scrolling on the x-axis or y-axis respectively,
- `pointer`, keep the mouse pointer above the same position on the chart when zooming.

In the example below, we set the anchor point for both axes to the mouse pointer.

#### Zoom Anchor Point

```ts
import { createApp, defineComponent, ref } from "vue";
import { AgCharts } from "ag-charts-vue3";
import type { AgChartOptions } from "ag-charts-types";
import {
  AnimationModule,
  CategoryAxisModule,
  ContextMenuModule,
  CrosshairModule,
  LegendModule,
  LineSeriesModule,
  ModuleRegistry,
  NumberAxisModule,
  ZoomModule,
} from "ag-charts-enterprise";
import { getData } from "./data";

ModuleRegistry.registerModules([
  AnimationModule,
  CategoryAxisModule,
  CrosshairModule,
  LegendModule,
  LineSeriesModule,
  NumberAxisModule,
  ZoomModule,
  ContextMenuModule,
]);

const ChartExample = defineComponent({
  template: `
    <ag-charts
      :options="options"
    />
  `,
  components: {
    "ag-charts": AgCharts,
  },
  setup(props) {
    const options = ref<AgCartesianChartOptions>({
      zoom: {
        enabled: true,
        axes: "xy",
        anchorPointX: "pointer",
        anchorPointY: "pointer",
      },
      tooltip: {
        enabled: false,
      },
      axes: {
        y: {
          type: "number",
          interval: {
            minSpacing: 80,
            maxSpacing: 120,
          },
        },
        x: {
          type: "number",
          nice: false,
          interval: {
            minSpacing: 80,
            maxSpacing: 120,
          },
          label: {
            autoRotate: false,
          },
        },
      },
      data: getData(),
      series: [
        {
          type: "line",
          xKey: "year",
          yKey: "spending",
        },
      ],
    });

    return {
      options,
    };
  },
});

createApp(ChartExample).mount("#app");
```

[Live example: Zoom Anchor Point](https://www.ag-grid.com/charts/archive/14.2.0/vue3/zoom/examples/zoom-anchor-point/)

```js
{
    zoom: {
        anchorPointX: 'pointer',
        anchorPointY: 'pointer',
    },
}
```

### Scrolling Step

When scrolling, the chart zooms in by a single step for each movement of the scroll wheel or trackpad. By default `scrollingStep` is set to `0.1`, or 10% of the chart each time.

In the example below, we change the step to `0.4`.

#### Zoom Scrolling Step

```ts
import { createApp, defineComponent, ref } from "vue";
import { AgCharts } from "ag-charts-vue3";
import type { AgChartOptions } from "ag-charts-types";
import {
  AnimationModule,
  ContextMenuModule,
  CrosshairModule,
  LegendModule,
  LineSeriesModule,
  ModuleRegistry,
  NumberAxisModule,
  ZoomModule,
} from "ag-charts-enterprise";
import { getData } from "./data";

ModuleRegistry.registerModules([
  AnimationModule,
  CrosshairModule,
  LegendModule,
  LineSeriesModule,
  NumberAxisModule,
  ZoomModule,
  ContextMenuModule,
]);

const ChartExample = defineComponent({
  template: `
    <ag-charts
      :options="options"
    />
  `,
  components: {
    "ag-charts": AgCharts,
  },
  setup(props) {
    const options = ref<AgCartesianChartOptions>({
      zoom: {
        enabled: true,
        scrollingStep: 0.4,
      },
      tooltip: {
        enabled: false,
      },
      axes: {
        y: {
          type: "number",
          interval: {
            minSpacing: 80,
            maxSpacing: 120,
          },
        },
        x: {
          type: "number",
          nice: false,
          interval: {
            minSpacing: 80,
            maxSpacing: 120,
          },
          label: {
            autoRotate: false,
          },
        },
      },
      data: getData(),
      series: [
        {
          type: "line",
          xKey: "year",
          yKey: "spending",
        },
      ],
    });

    return {
      options,
    };
  },
});

createApp(ChartExample).mount("#app");
```

[Live example: Zoom Scrolling Step](https://www.ag-grid.com/charts/archive/14.2.0/vue3/zoom/examples/zoom-scrolling-step/)

```js
{
    zoom: {
        scrollingStep: 0.4,
    },
}
```

### Axes

By default, scrolling zoom is only enabled for the `x` axis. This can be changed by setting the `axes` property to `x`, `y` or `xy`.

In the example below, we enable zoom on both the `x` and `y` axes.

#### Zoom Axes

```ts
import { createApp, defineComponent, ref } from "vue";
import { AgCharts } from "ag-charts-vue3";
import type { AgChartOptions } from "ag-charts-types";
import {
  AnimationModule,
  CategoryAxisModule,
  ContextMenuModule,
  CrosshairModule,
  LegendModule,
  LineSeriesModule,
  ModuleRegistry,
  NumberAxisModule,
  ZoomModule,
} from "ag-charts-enterprise";
import { getData } from "./data";

ModuleRegistry.registerModules([
  AnimationModule,
  CategoryAxisModule,
  CrosshairModule,
  LegendModule,
  LineSeriesModule,
  NumberAxisModule,
  ZoomModule,
  ContextMenuModule,
]);

const ChartExample = defineComponent({
  template: `
    <ag-charts
      :options="options"
    />
  `,
  components: {
    "ag-charts": AgCharts,
  },
  setup(props) {
    const options = ref<AgCartesianChartOptions>({
      zoom: {
        enabled: true,
        axes: "xy",
      },
      tooltip: {
        enabled: false,
      },
      axes: {
        y: {
          type: "number",
          interval: {
            minSpacing: 80,
            maxSpacing: 120,
          },
        },
        x: {
          type: "number",
          nice: false,
          interval: {
            minSpacing: 80,
            maxSpacing: 120,
          },
          label: {
            autoRotate: false,
          },
        },
      },
      data: getData(),
      series: [
        {
          type: "line",
          xKey: "year",
          yKey: "spending",
        },
      ],
    });

    return {
      options,
    };
  },
});

createApp(ChartExample).mount("#app");
```

[Live example: Zoom Axes](https://www.ag-grid.com/charts/archive/14.2.0/vue3/zoom/examples/zoom-axes/)

```js
{
    zoom: {
        axes: 'xy',
    },
}
```

### Scrolling Mode

By default, vertical mouse wheel or trackpad scrolling zooms the chart. Set `scrollingMode: 'pan'` to pan instead.

#### Zoom Scrolling Mode

```ts
import { createApp, defineComponent, ref } from "vue";
import { AgCharts } from "ag-charts-vue3";
import type { AgChartOptions } from "ag-charts-types";
import {
  AnimationModule,
  BarSeriesModule,
  CategoryAxisModule,
  ContextMenuModule,
  ModuleRegistry,
  NumberAxisModule,
  ZoomModule,
} from "ag-charts-enterprise";
import { getData } from "./data";
import clone from "clone";

ModuleRegistry.registerModules([
  AnimationModule,
  BarSeriesModule,
  CategoryAxisModule,
  NumberAxisModule,
  ZoomModule,
  ContextMenuModule,
]);

const ChartExample = defineComponent({
  template: `
    <div class="example-controls">
      <div class="controls-row">
        <span>Scrolling Mode:</span>
        <div class="button-group" role="group" aria-label="Scrolling Mode">
          <input type="radio" id="scrolling-zoom" name="scrolling-mode" value="zoom" checked="" v-on:change="setScrollingMode($event)">
            <label for="scrolling-zoom">Zoom</label>
            <input type="radio" id="scrolling-pan" name="scrolling-mode" value="pan" v-on:change="setScrollingMode($event)">
              <label for="scrolling-pan">Pan</label>
            </div>
          </div>
        </div>
        <ag-charts
          :options="options"
        />
  `,
  components: {
    "ag-charts": AgCharts,
  },
  setup(props) {
    const options = ref<AgCartesianChartOptions>({
      zoom: {
        enabled: true,
        scrollingMode: "zoom",
      },
      title: {
        text: "Population by Country (millions)",
      },
      initialState: {
        zoom: {
          ratioY: { start: 0.6 },
        },
      },
      axes: {
        x: {
          type: "number",
          label: {
            formatter: (params) => `${params.value}M`,
          },
        },
      },
      data: getData(),
      series: [
        {
          type: "bar",
          direction: "horizontal",
          xKey: "country",
          yKey: "population",
          yName: "Population (millions)",
        },
      ],
    });

    const setScrollingMode = (event) => {
      const optionsCopy = clone(options.value);

      optionsCopy.zoom.scrollingMode = event.target.value;

      options.value = optionsCopy;
    };

    return {
      options,
      setScrollingMode,
    };
  },
});

createApp(ChartExample).mount("#app");
```

[Live example: Zoom Scrolling Mode](https://www.ag-grid.com/charts/archive/14.2.0/vue3/zoom/examples/zoom-scrolling-mode/)

```js
{
    zoom: {
        scrollingMode: 'pan',
    },
}
```

## Panning

This is enabled by default and allows users to click and drag to move around a zoomed chart. To disable, use `enablePanning: false`.

If [zoom by selecting](https://www.ag-grid.com/charts/archive/14.2.0/vue/zoom/#selecting) is enabled, clicking and dragging will no longer pan by default. Instead the user will need to hold down a key to switch to panning mode.

This key defaults to `alt` but can be set with the `panKey` property to one of `alt`, `ctrl`, `shift` or `meta` (the command key on MacOS or start key on Windows).

In the example below, panning can only be done by holding down the `shift` key while clicking and dragging.

#### Zoom Pan Key

```ts
import { createApp, defineComponent, ref } from "vue";
import { AgCharts } from "ag-charts-vue3";
import type { AgChartOptions } from "ag-charts-types";
import {
  AnimationModule,
  ContextMenuModule,
  CrosshairModule,
  LegendModule,
  LineSeriesModule,
  ModuleRegistry,
  NumberAxisModule,
  ZoomModule,
} from "ag-charts-enterprise";
import { getData } from "./data";

ModuleRegistry.registerModules([
  AnimationModule,
  CrosshairModule,
  LegendModule,
  LineSeriesModule,
  NumberAxisModule,
  ZoomModule,
  ContextMenuModule,
]);

const ChartExample = defineComponent({
  template: `
    <ag-charts
      :options="options"
    />
  `,
  components: {
    "ag-charts": AgCharts,
  },
  setup(props) {
    const options = ref<AgCartesianChartOptions>({
      zoom: {
        enabled: true,
        enableSelecting: true,
        panKey: "shift",
      },
      tooltip: {
        enabled: false,
      },
      axes: {
        y: {
          type: "number",
          interval: {
            minSpacing: 80,
            maxSpacing: 120,
          },
        },
        x: {
          type: "number",
          nice: false,
          interval: {
            minSpacing: 80,
            maxSpacing: 120,
          },
          label: {
            autoRotate: false,
          },
        },
      },
      data: getData(),
      series: [
        {
          type: "line",
          xKey: "year",
          yKey: "spending",
        },
      ],
    });

    return {
      options,
    };
  },
});

createApp(ChartExample).mount("#app");
```

[Live example: Zoom Pan Key](https://www.ag-grid.com/charts/archive/14.2.0/vue3/zoom/examples/zoom-pan-key/)

```js
{
    zoom: {
        panKey: 'shift',
    },
}
```

## Selecting

This method of zooming works by clicking and dragging a box to select an area on the chart. This is disabled by default. To enable, use `enableSelecting: true`.

In the example below, the user can only zoom in by selection, and can only zoom out by double-click to reset.

#### Zoom Selecting

```ts
import { createApp, defineComponent, ref } from "vue";
import { AgCharts } from "ag-charts-vue3";
import type { AgChartOptions } from "ag-charts-types";
import {
  AnimationModule,
  ContextMenuModule,
  CrosshairModule,
  LegendModule,
  LineSeriesModule,
  ModuleRegistry,
  NumberAxisModule,
  ZoomModule,
} from "ag-charts-enterprise";
import { getData } from "./data";

ModuleRegistry.registerModules([
  AnimationModule,
  CrosshairModule,
  LegendModule,
  LineSeriesModule,
  NumberAxisModule,
  ZoomModule,
  ContextMenuModule,
]);

const ChartExample = defineComponent({
  template: `
    <ag-charts
      :options="options"
    />
  `,
  components: {
    "ag-charts": AgCharts,
  },
  setup(props) {
    const options = ref<AgCartesianChartOptions>({
      zoom: {
        enableAxisDragging: false,
        enablePanning: false,
        enableScrolling: false,
        enableSelecting: true,
      },
      tooltip: {
        enabled: false,
      },
      axes: {
        y: {
          type: "number",
          interval: {
            minSpacing: 80,
            maxSpacing: 120,
          },
        },
        x: {
          type: "number",
          nice: false,
          interval: {
            minSpacing: 80,
            maxSpacing: 120,
          },
          label: {
            autoRotate: false,
          },
        },
      },
      data: getData(),
      series: [
        {
          type: "line",
          xKey: "year",
          yKey: "spending",
        },
      ],
    });

    return {
      options,
    };
  },
});

createApp(ChartExample).mount("#app");
```

[Live example: Zoom Selecting](https://www.ag-grid.com/charts/archive/14.2.0/vue3/zoom/examples/zoom-selecting/)

```js
{
    zoom: {
        enableAxisDragging: false,
        enablePanning: false,
        enableScrolling: false,
        enableSelecting: true,
    },
}
```

## Two Finger Zoom-Pan

By default, using two fingers to pinch in or out will zoom the chart. It is also possible to use two fingers to pan a zoomed chart.

To disable this behaviour, use `enableTwoFingerZoom: false`.

#### Two Finger Zoom-Pan Disabled

```ts
import { createApp, defineComponent, ref } from "vue";
import { AgCharts } from "ag-charts-vue3";
import type { AgChartOptions } from "ag-charts-types";
import {
  AnimationModule,
  ContextMenuModule,
  CrosshairModule,
  LegendModule,
  LineSeriesModule,
  ModuleRegistry,
  NumberAxisModule,
  ZoomModule,
} from "ag-charts-enterprise";
import { getData } from "./data";

ModuleRegistry.registerModules([
  AnimationModule,
  CrosshairModule,
  LegendModule,
  LineSeriesModule,
  NumberAxisModule,
  ZoomModule,
  ContextMenuModule,
]);

const ChartExample = defineComponent({
  template: `
    <ag-charts
      :options="options"
    />
  `,
  components: {
    "ag-charts": AgCharts,
  },
  setup(props) {
    const options = ref<AgCartesianChartOptions>({
      zoom: {
        enableTwoFingerZoom: false,
      },
      initialState: {
        zoom: {
          ratioX: { start: 0.48, end: 0.52 },
          ratioY: { start: 0.21, end: 0.82 },
        },
      },
      tooltip: {
        enabled: false,
      },
      axes: {
        y: {
          type: "number",
          interval: {
            minSpacing: 80,
            maxSpacing: 120,
          },
        },
        x: {
          type: "number",
          nice: false,
          interval: {
            minSpacing: 80,
            maxSpacing: 120,
          },
          label: {
            autoRotate: false,
          },
        },
      },
      data: getData(),
      series: [
        {
          type: "line",
          xKey: "year",
          yKey: "spending",
        },
      ],
    });

    return {
      options,
    };
  },
});

createApp(ChartExample).mount("#app");
```

[Live example: Two Finger Zoom-Pan Disabled](https://www.ag-grid.com/charts/archive/14.2.0/vue3/zoom/examples/two-finger-disabled/)

```js
{
    zoom: {
        enableTwoFingerZoom: false,
    },
}
```

In the above example:

- Two fingers gestures are not consumed by the chart. Instead they zoom or scroll the entire page.

## Axis Zoom Controls

By default, a user can click and drag on any axis to change the zoom of that axis. This ignores the `axes` property and is enabled by default for all axes.

#### Axis Zoom Controls

```ts
import { createApp, defineComponent, ref } from "vue";
import { AgCharts } from "ag-charts-vue3";
import type { AgChartOptions } from "ag-charts-types";
import {
  AnimationModule,
  ContextMenuModule,
  CrosshairModule,
  LegendModule,
  LineSeriesModule,
  ModuleRegistry,
  NumberAxisModule,
  ZoomModule,
} from "ag-charts-enterprise";
import { getData } from "./data";
import clone from "clone";

ModuleRegistry.registerModules([
  AnimationModule,
  CrosshairModule,
  LegendModule,
  LineSeriesModule,
  NumberAxisModule,
  ZoomModule,
  ContextMenuModule,
]);

const ChartExample = defineComponent({
  template: `
    <div class="example-controls">
      <div class="controls-row">
        <label for="enable-dragging">Axis Dragging:</label>
        <select id="enable-dragging" v-on:change="enableAxisDragging($event.target.value)" class="gap-right">
          <option value="on">Enabled</option>
          <option value="off">Disabled</option>
        </select>
        <label for="dragging-mode">Axis Dragging Mode:</label>
        <select id="dragging-mode" v-on:change="setAxisDragging($event.target.value)" class="gap-right">
          <option value="zoom">Zoom</option>
          <option value="pan">Pan</option>
        </select>
        <label for="enable-scrolling">Axis Scrolling:</label>
        <select id="enable-scrolling" v-on:change="enableAxisScrolling($event.target.value)">
          <option value="on">Enabled</option>
          <option value="off">Disabled</option>
        </select>
      </div>
    </div>
    <ag-charts
      :options="options"
    />
  `,
  components: {
    "ag-charts": AgCharts,
  },
  setup(props) {
    const options = ref<AgCartesianChartOptions>({
      zoom: {
        enabled: true,
        enableAxisDragging: true,
        enableAxisScrolling: true,
        axisDraggingMode: "zoom",
      },
      tooltip: {
        enabled: false,
      },
      axes: {
        y: {
          type: "number",
          position: "left",
          title: {
            text: "Spending",
          },
          interval: {
            minSpacing: 80,
            maxSpacing: 120,
          },
        },
        ySecondary: {
          type: "number",
          position: "right",
          title: {
            text: "Tonnes",
          },
          interval: {
            minSpacing: 80,
            maxSpacing: 120,
          },
        },
        x: {
          type: "number",
          nice: false,
          interval: {
            minSpacing: 80,
            maxSpacing: 120,
          },
          label: {
            autoRotate: false,
          },
        },
      },
      data: getData(),
      series: [
        {
          type: "line",
          xKey: "year",
          yKey: "spending",
        },
        {
          type: "line",
          xKey: "year",
          yKey: "tonnes",
          yKeyAxis: "ySecondary",
        },
      ],
    });

    const setAxisDragging = (mode) => {
      const optionsCopy = clone(options.value);

      optionsCopy.zoom.axisDraggingMode = mode;

      options.value = optionsCopy;
    };
    const enableAxisDragging = (enabled) => {
      const optionsCopy = clone(options.value);

      optionsCopy.zoom.enableAxisDragging = enabled === "on";

      options.value = optionsCopy;
    };
    const enableAxisScrolling = (enabled) => {
      const optionsCopy = clone(options.value);

      optionsCopy.zoom.enableAxisScrolling = enabled === "on";

      options.value = optionsCopy;
    };

    return {
      options,
      setAxisDragging,
      enableAxisDragging,
      enableAxisScrolling,
    };
  },
});

createApp(ChartExample).mount("#app");
```

[Live example: Axis Zoom Controls](https://www.ag-grid.com/charts/archive/14.2.0/vue3/zoom/examples/zoom-axis-controls/)

- When using `axisDraggingMode: 'zoom'` (default), dragging either of the y-axes will zoom both of them.
- Use `axisDraggingMode: 'pan'` to pan while dragging an axis.
- Use `enableAxisDragging: false` to disable all axis dragging.
- Scrolling on an axis to zoom is enabled by default. Use `enableAxisScrolling: false` to disable it.

## Double-Click to Reset

This allows users to reset the zoom by double-clicking in an empty space in the chart area, and is enabled by default. To disable, use `enableDoubleClickToReset: false`.

## Minimum Visible Items

The `minVisibleItems` option can be used to limit how far a user can zoom in to the chart.

The example below demonstrates setting `minVisibleItems` to `10`, preventing the user from zooming beyond showing a minimum of 10 points on the line.

#### Zoom Min Visible Items

```ts
import { createApp, defineComponent, ref } from "vue";
import { AgCharts } from "ag-charts-vue3";
import type { AgChartOptions } from "ag-charts-types";
import {
  AnimationModule,
  ContextMenuModule,
  CrosshairModule,
  LegendModule,
  LineSeriesModule,
  ModuleRegistry,
  NumberAxisModule,
  ZoomModule,
} from "ag-charts-enterprise";
import { getData } from "./data";

ModuleRegistry.registerModules([
  AnimationModule,
  ContextMenuModule,
  CrosshairModule,
  LegendModule,
  LineSeriesModule,
  NumberAxisModule,
  ZoomModule,
]);

const ChartExample = defineComponent({
  template: `
    <ag-charts
      :options="options"
    />
  `,
  components: {
    "ag-charts": AgCharts,
  },
  setup(props) {
    const options = ref<AgCartesianChartOptions>({
      zoom: {
        minVisibleItems: 10,
      },
      tooltip: {
        enabled: false,
      },
      axes: {
        y: {
          type: "number",
          interval: {
            minSpacing: 80,
            maxSpacing: 120,
          },
        },
        x: {
          type: "number",
          nice: false,
          interval: {
            minSpacing: 80,
            maxSpacing: 120,
          },
          label: {
            autoRotate: false,
          },
        },
      },
      data: getData(),
      series: [
        {
          type: "line",
          xKey: "year",
          yKey: "spending",
        },
      ],
    });

    return {
      options,
    };
  },
});

createApp(ChartExample).mount("#app");
```

[Live example: Zoom Min Visible Items](https://www.ag-grid.com/charts/archive/14.2.0/vue3/zoom/examples/zoom-min-visible-items/)

```js
{
    zoom: {
        minVisibleItems: 10,
    },
}
```

## Auto Scaling

Auto Scaling dynamically adjusts the y-axis to fit the visible data whenever the x-axis is zoomed or panned. This is enabled by default when zooming the x-axis. To disable, use `autoScaling: false`.

#### Auto Scaling

```ts
import { createApp, defineComponent, ref } from "vue";
import { AgCharts } from "ag-charts-vue3";
import type { AgChartOptions } from "ag-charts-types";
import {
  AnimationModule,
  CandlestickSeriesModule,
  ContextMenuModule,
  CrosshairModule,
  LegendModule,
  ModuleRegistry,
  NavigatorModule,
  NumberAxisModule,
  OrdinalTimeAxisModule,
  ZoomModule,
} from "ag-charts-enterprise";
import { getData } from "./data";
import clone from "clone";

ModuleRegistry.registerModules([
  AnimationModule,
  CandlestickSeriesModule,
  CrosshairModule,
  LegendModule,
  NavigatorModule,
  NumberAxisModule,
  OrdinalTimeAxisModule,
  ZoomModule,
  ContextMenuModule,
]);

const ChartExample = defineComponent({
  template: `
    <div class="example-controls">
      <div class="controls-row">
        <div class="button-group" role="group" aria-label="Auto Scaling">
          <input type="radio" id="auto-scaling-disabled" name="auto-scaling" value="false" v-on:change="setAutoScaling($event)">
            <label for="auto-scaling-disabled">Disabled</label>
            <input type="radio" id="auto-scaling-enabled" name="auto-scaling" value="true" checked="" v-on:change="setAutoScaling($event)">
              <label for="auto-scaling-enabled">Enabled</label>
            </div>
          </div>
        </div>
        <ag-charts
          :options="options"
        />
  `,
  components: {
    "ag-charts": AgCharts,
  },
  setup(props) {
    const options = ref<AgCartesianChartOptions>({
      data: getData(1e3),
      animation: { enabled: false },
      zoom: {
        enabled: true,
        anchorPointX: "pointer",
        anchorPointY: "pointer",
        autoScaling: {
          enabled: true,
        },
      },
      navigator: {
        enabled: true,
        miniChart: {
          enabled: true,
        },
      },
      series: [
        {
          type: "candlestick",
          xKey: "timestamp",
          lowKey: "low",
          highKey: "high",
          openKey: "open",
          closeKey: "close",
        },
      ],
    });

    const setAutoScaling = (event) => {
      const optionsCopy = clone(options.value);

      const autoScaling = event.target.value === "true";
      optionsCopy.zoom.autoScaling.enabled = autoScaling;

      options.value = optionsCopy;
    };

    return {
      options,
      setAutoScaling,
    };
  },
});

createApp(ChartExample).mount("#app");
```

[Live example: Auto Scaling](https://www.ag-grid.com/charts/archive/14.2.0/vue3/zoom/examples/auto-scaling/)

```js
{
    zoom: {
        autoScaling: {
            enabled: false,
        },
    },
}
```

In the above example:

- Zoom in to the chart by scrolling and then pan left and right.
- Observe how the vertical axis domain changes to fit the displayed data range.

Auto Scaling is never applied when the user has manually adjusted the y-axis by dragging it. Auto Scaling will be reapplied when the y-axis is reset, for example by double clicking on it.

## On Data Change

When data is updated while the chart is zoomed, the `zoom.onDataChange` options control how the zoomed view adjusts. This helps users maintain their focus when data changes, or always see the latest data.

The default strategy is `preserveDomain`, use `onDataChange.strategy` to change to one of the below.

### Preserve Domain

`strategy: 'preserveDomain'` preserves the current axis domain when data changes, keeping the view at the exact domain values if possible.

This is useful for appending data without disrupting users viewing a specific time period in the middle of the data.

#### Preserve Domain

```ts
import { createApp, defineComponent, ref } from "vue";
import { AgCharts } from "ag-charts-vue3";
import type { AgChartOptions } from "ag-charts-types";
import {
  LineSeriesModule,
  ModuleRegistry,
  NavigatorModule,
  NumberAxisModule,
  TimeAxisModule,
  ZoomModule,
} from "ag-charts-enterprise";
import { getData, getNextDataPoint } from "./data";
import clone from "clone";

let data = getData();

let streamingInterval = null;

ModuleRegistry.registerModules([
  LineSeriesModule,
  NavigatorModule,
  NumberAxisModule,
  TimeAxisModule,
  ZoomModule,
]);

const ChartExample = defineComponent({
  template: `
    <div class="example-controls">
      <div class="controls-row">
        <button v-on:click="startUpdates()">Start Updates</button>
        <button v-on:click="stopUpdates()">Stop Updates</button>
        <button v-on:click="resetData()">Reset</button>
      </div>
    </div>
    <ag-charts
      ref="agCharts"
      :options="options"
    />
  `,
  components: {
    "ag-charts": AgCharts,
  },
  setup(props) {
    const options = ref<AgCartesianChartOptions>({
      data,
      series: [
        {
          type: "line",
          xKey: "date",
          yKey: "price",
          marker: { enabled: false },
        },
      ],
      axes: {
        x: {
          type: "time",
          nice: false,
        },
        y: {
          type: "number",
          title: { text: "Price" },
        },
      },
      zoom: {
        enabled: true,
        onDataChange: {
          strategy: "preserveDomain",
        },
      },
      navigator: {
        enabled: true,
        miniChart: {
          enabled: true,
        },
      },
      initialState: {
        zoom: {
          ratioX: { start: 0.3, end: 0.7 },
        },
      },
    });
    const agCharts = ref(null);

    const startUpdates = () => {
      if (streamingInterval) return;
      streamingInterval = setInterval(() => {
        const nextPoint = getNextDataPoint(data);
        data.push(nextPoint);
        agCharts.value.chart.applyTransaction({ add: [nextPoint] });
      }, 100);
    };
    const stopUpdates = () => {
      if (streamingInterval) {
        clearInterval(streamingInterval);
        streamingInterval = null;
      }
    };
    const resetData = () => {
      const optionsCopy = clone(options.value);

      stopUpdates();
      data = getData();
      optionsCopy.data = data;

      options.value = optionsCopy;
    };

    return {
      options,
      agCharts,
      startUpdates,
      stopUpdates,
      resetData,
    };
  },
});

createApp(ChartExample).mount("#app");
```

[Live example: Preserve Domain](https://www.ag-grid.com/charts/archive/14.2.0/vue3/zoom/examples/on-data-change-preserve-domain/)

```js
{
    zoom: {
        enabled: true,
        onDataChange: {
            strategy: 'preserveDomain',
        },
    },
}
```

In this example:

- The chart is initially zoomed to the middle of the data.
- Start the updates to see new data appended at the end.
- Notice in the Navigator that new data has been added, but the chart view remains fixed on the same time range.

### Preserve Ratios

`strategy: 'preserveRatios'`, preserves the same zoom percentages regardless of data changes.

This is useful for maintaining a consistent proportional view of your data, with more data points becoming visible as the dataset grows.

#### Preserve Ratios

```ts
import { createApp, defineComponent, ref } from "vue";
import { AgCharts } from "ag-charts-vue3";
import type { AgChartOptions } from "ag-charts-types";
import {
  LineSeriesModule,
  ModuleRegistry,
  NavigatorModule,
  NumberAxisModule,
  TimeAxisModule,
  ZoomModule,
} from "ag-charts-enterprise";
import { getData, getNextDataPoint } from "./data";
import clone from "clone";

let data = getData();

let streamingInterval = null;

ModuleRegistry.registerModules([
  LineSeriesModule,
  NavigatorModule,
  NumberAxisModule,
  TimeAxisModule,
  ZoomModule,
]);

const ChartExample = defineComponent({
  template: `
    <div class="example-controls">
      <div class="controls-row">
        <button v-on:click="startUpdates()">Start Updates</button>
        <button v-on:click="stopUpdates()">Stop Updates</button>
        <button v-on:click="resetData()">Reset</button>
      </div>
    </div>
    <ag-charts
      ref="agCharts"
      :options="options"
    />
  `,
  components: {
    "ag-charts": AgCharts,
  },
  setup(props) {
    const options = ref<AgCartesianChartOptions>({
      data,
      series: [
        {
          type: "line",
          xKey: "date",
          yKey: "price",
          marker: { enabled: false },
        },
      ],
      axes: {
        x: {
          type: "time",
          nice: false,
        },
        y: {
          type: "number",
          title: { text: "Price" },
        },
      },
      zoom: {
        enabled: true,
        onDataChange: {
          strategy: "preserveRatios",
        },
      },
      navigator: {
        enabled: true,
        miniChart: {
          enabled: true,
        },
      },
      initialState: {
        zoom: {
          ratioX: { start: 0.8, end: 1 },
        },
      },
    });
    const agCharts = ref(null);

    const startUpdates = () => {
      if (streamingInterval) return;
      streamingInterval = setInterval(() => {
        const newPoints = [];
        for (let i = 0; i < 10; i++) {
          const nextPoint = getNextDataPoint(data);
          data.push(nextPoint);
          newPoints.push(nextPoint);
        }
        agCharts.value.chart.applyTransaction({ add: newPoints });
      }, 200);
    };
    const stopUpdates = () => {
      if (streamingInterval) {
        clearInterval(streamingInterval);
        streamingInterval = null;
      }
    };
    const resetData = () => {
      const optionsCopy = clone(options.value);

      stopUpdates();
      data = getData();
      optionsCopy.data = data;

      options.value = optionsCopy;
    };

    return {
      options,
      agCharts,
      startUpdates,
      stopUpdates,
      resetData,
    };
  },
});

createApp(ChartExample).mount("#app");
```

[Live example: Preserve Ratios](https://www.ag-grid.com/charts/archive/14.2.0/vue3/zoom/examples/on-data-change-preserve-ratio/)

```js
{
    zoom: {
        enabled: true,
        onDataChange: {
            strategy: 'preserveRatios',
        },
    },
}
```

In this example:

- The chart is initially zoomed to the last 20% of the data.
- Start the updates to see new data points added in batches.
- Notice that more data points become visible in the chart view as total data grows, since the zoom ratio stays at 80%-100%.

### Reset

`strategy: 'reset'`, resets the zoom to the `initialState` or no zoom, whenever the data changes.

This is useful for switching between unrelated datasets, discarding previous user interactions and reverting to a predefined starting view.

#### Reset

```ts
import { createApp, defineComponent, ref } from "vue";
import { AgCharts } from "ag-charts-vue3";
import type { AgChartOptions } from "ag-charts-types";
import {
  LineSeriesModule,
  ModuleRegistry,
  NavigatorModule,
  NumberAxisModule,
  TimeAxisModule,
  ZoomModule,
} from "ag-charts-enterprise";
import { getDatasetA, getDatasetB } from "./data";
import clone from "clone";

ModuleRegistry.registerModules([
  LineSeriesModule,
  NavigatorModule,
  NumberAxisModule,
  TimeAxisModule,
  ZoomModule,
]);

const ChartExample = defineComponent({
  template: `
    <div class="example-controls">
      <div class="controls-row">
        <button v-on:click="loadDatasetA()">Load Dataset A</button>
        <button v-on:click="loadDatasetB()">Load Dataset B</button>
      </div>
    </div>
    <ag-charts
      :options="options"
    />
  `,
  components: {
    "ag-charts": AgCharts,
  },
  setup(props) {
    const options = ref<AgCartesianChartOptions>({
      data: getDatasetA(),
      series: [
        {
          type: "line",
          xKey: "date",
          yKey: "price",
          marker: { enabled: false },
        },
      ],
      axes: {
        x: {
          type: "time",
          nice: false,
        },
        y: {
          type: "number",
          title: { text: "Price" },
        },
      },
      zoom: {
        enabled: true,
        onDataChange: {
          strategy: "reset",
        },
      },
      navigator: {
        enabled: true,
        miniChart: {
          enabled: true,
        },
      },
      initialState: {
        zoom: {
          ratioX: { start: 0.9, end: 1 },
        },
      },
    });

    const loadDatasetA = () => {
      const optionsCopy = clone(options.value);

      optionsCopy.data = getDatasetA();

      options.value = optionsCopy;
    };
    const loadDatasetB = () => {
      const optionsCopy = clone(options.value);

      optionsCopy.data = getDatasetB();

      options.value = optionsCopy;
    };

    return {
      options,
      loadDatasetA,
      loadDatasetB,
    };
  },
});

createApp(ChartExample).mount("#app");
```

[Live example: Reset](https://www.ag-grid.com/charts/archive/14.2.0/vue3/zoom/examples/on-data-change-reset/)

```js
{
    zoom: {
        enabled: true,
        onDataChange: {
            strategy: 'reset',
        },
    },
}
```

In this example:

- The chart is initially zoomed to show only the last few data points.
- Pan or zoom to a different position in the chart.
- Click a button to switch datasets and notice that the zoom resets to the initial state.

### Stick to End

The `stickToEnd` option automatically scrolls to keep the latest data visible when new data is appended and the view is already at the end of the data range. Use `stickToEnd: true` to enable.

When `stickToEnd` is active, it takes precedence over the configured strategy. Once the user pans away from the end, the configured strategy (e.g., `preserveDomain`) takes over until they return to viewing the end.

#### Stick to End

```ts
import { createApp, defineComponent, ref } from "vue";
import { AgCharts } from "ag-charts-vue3";
import type { AgChartOptions } from "ag-charts-types";
import {
  LineSeriesModule,
  ModuleRegistry,
  NavigatorModule,
  NumberAxisModule,
  TimeAxisModule,
  ZoomModule,
} from "ag-charts-enterprise";
import { getData, getNextDataPoint } from "./data";
import clone from "clone";

let data = getData();

let streamingInterval = null;

ModuleRegistry.registerModules([
  LineSeriesModule,
  NavigatorModule,
  NumberAxisModule,
  TimeAxisModule,
  ZoomModule,
]);

const ChartExample = defineComponent({
  template: `
    <div class="example-controls">
      <div class="controls-row">
        <button v-on:click="startUpdates()">Start Updates</button>
        <button v-on:click="stopUpdates()">Stop Updates</button>
        <button v-on:click="resetData()">Reset</button>
      </div>
    </div>
    <ag-charts
      ref="agCharts"
      :options="options"
    />
  `,
  components: {
    "ag-charts": AgCharts,
  },
  setup(props) {
    const options = ref<AgCartesianChartOptions>({
      data,
      series: [
        {
          type: "line",
          xKey: "date",
          yKey: "price",
          marker: { enabled: false },
        },
      ],
      axes: {
        x: {
          type: "time",
          nice: false,
        },
        y: {
          type: "number",
          title: { text: "Price" },
        },
      },
      zoom: {
        enabled: true,
        onDataChange: {
          strategy: "preserveDomain",
          stickToEnd: true,
        },
      },
      navigator: {
        enabled: true,
        miniChart: {
          enabled: true,
        },
      },
      initialState: {
        zoom: {
          ratioX: { start: 0.6, end: 1 },
        },
      },
    });
    const agCharts = ref(null);

    const startUpdates = () => {
      if (streamingInterval) return;
      streamingInterval = setInterval(() => {
        const nextPoint = getNextDataPoint(data);
        data.push(nextPoint);
        agCharts.value.chart.applyTransaction({ add: [nextPoint] });
      }, 100);
    };
    const stopUpdates = () => {
      if (streamingInterval) {
        clearInterval(streamingInterval);
        streamingInterval = null;
      }
    };
    const resetData = () => {
      const optionsCopy = clone(options.value);

      stopUpdates();
      data = getData();
      optionsCopy.data = data;

      options.value = optionsCopy;
    };

    return {
      options,
      agCharts,
      startUpdates,
      stopUpdates,
      resetData,
    };
  },
});

createApp(ChartExample).mount("#app");
```

[Live example: Stick to End](https://www.ag-grid.com/charts/archive/14.2.0/vue3/zoom/examples/on-data-change-stick-to-end/)

```js
{
    zoom: {
        enabled: true,
        onDataChange: {
            strategy: 'preserveDomain',
            stickToEnd: true,
        },
    },
}
```

In this example:

- The chart is initially zoomed to the end of the data.
- Start the updates to see new data appended and the view scrolls to follow.
- Pan away from the end to see the `preserveDomain` strategy take over with a fixed view.
- Pan back to the end and the view will resume following new data.

## Navigator

The zoom functionality can be used together with the [Navigator](https://www.ag-grid.com/charts/archive/14.2.0/vue/navigator/) to add a visual reference to the zoom position.

## Context Menu

When both the zoom and [Context Menu](https://www.ag-grid.com/charts/archive/14.2.0/vue/context-menu/) are enabled, additional zoom actions are added into the Context Menu for zooming and panning to the clicked location.

#### Zoom Context Menu

```ts
import { createApp, defineComponent, ref } from "vue";
import { AgCharts } from "ag-charts-vue3";
import type { AgChartOptions } from "ag-charts-types";
import {
  AnimationModule,
  ContextMenuModule,
  CrosshairModule,
  LegendModule,
  LineSeriesModule,
  ModuleRegistry,
  NumberAxisModule,
  ZoomModule,
} from "ag-charts-enterprise";
import { getData } from "./data";

ModuleRegistry.registerModules([
  AnimationModule,
  ContextMenuModule,
  CrosshairModule,
  LegendModule,
  LineSeriesModule,
  NumberAxisModule,
  ZoomModule,
]);

const ChartExample = defineComponent({
  template: `
    <ag-charts
      :options="options"
    />
  `,
  components: {
    "ag-charts": AgCharts,
  },
  setup(props) {
    const options = ref<AgCartesianChartOptions>({
      zoom: {
        enabled: true,
      },
      contextMenu: {
        enabled: true,
      },
      tooltip: {
        enabled: false,
      },
      axes: {
        y: {
          type: "number",
          interval: {
            minSpacing: 80,
            maxSpacing: 120,
          },
        },
        x: {
          type: "number",
          nice: false,
          interval: {
            minSpacing: 80,
            maxSpacing: 120,
          },
          label: {
            autoRotate: false,
          },
        },
      },
      data: getData(),
      series: [
        {
          type: "line",
          xKey: "year",
          yKey: "spending",
        },
      ],
    });

    return {
      options,
    };
  },
});

createApp(ChartExample).mount("#app");
```

[Live example: Zoom Context Menu](https://www.ag-grid.com/charts/archive/14.2.0/vue3/zoom/examples/zoom-context-menu/)

## Buttons

Zoom buttons are enabled by default. To disable, use `zoom.buttons.enabled: false`.

#### Zoom Buttons

```ts
import { createApp, defineComponent, ref } from "vue";
import { AgCharts } from "ag-charts-vue3";
import type { AgChartOptions } from "ag-charts-types";
import {
  AnimationModule,
  ContextMenuModule,
  CrosshairModule,
  LegendModule,
  LineSeriesModule,
  ModuleRegistry,
  NumberAxisModule,
  UnitTimeAxisModule,
  ZoomModule,
} from "ag-charts-enterprise";
import { getData } from "./data";
import clone from "clone";

ModuleRegistry.registerModules([
  AnimationModule,
  CrosshairModule,
  LegendModule,
  LineSeriesModule,
  NumberAxisModule,
  UnitTimeAxisModule,
  ZoomModule,
  ContextMenuModule,
]);

const ChartExample = defineComponent({
  template: `
    <div class="example-controls">
      <div class="controls-row">
        <span>Visible:</span>
        <div class="button-group" role="group" aria-label="Visible">
          <input type="radio" id="visible-always" name="visible" value="always" v-on:change="changeVisible($event)">
            <label for="visible-always">Always</label>
            <input type="radio" id="visible-zoomed" name="visible" value="zoomed" v-on:change="changeVisible($event)">
              <label for="visible-zoomed">Zoomed</label>
              <input type="radio" id="visible-hover" name="visible" value="hover" checked="" v-on:change="changeVisible($event)">
                <label for="visible-hover">Hover Region</label>
              </div>
            </div>
          </div>
          <ag-charts
            :options="options"
          />
  `,
  components: {
    "ag-charts": AgCharts,
  },
  setup(props) {
    const options = ref<AgCartesianChartOptions>({
      zoom: {
        enabled: true,
        buttons: {
          visible: "hover",
        },
      },
      tooltip: {
        enabled: false,
      },
      axes: {
        x: {
          type: "unit-time",
          interval: {
            minSpacing: 50,
            maxSpacing: 200,
          },
          label: {
            autoRotate: false,
          },
          crosshair: {
            label: {
              format: `%d %b %Y`,
            },
          },
        },
      },
      data: getData(),
      series: [
        {
          type: "line",
          xKey: "time",
          yKey: "price",
        },
      ],
    });

    const changeVisible = (event) => {
      const optionsCopy = clone(options.value);

      optionsCopy.zoom.buttons.visible = event.target.value;

      options.value = optionsCopy;
    };

    return {
      options,
      changeVisible,
    };
  },
});

createApp(ChartExample).mount("#app");
```

[Live example: Zoom Buttons](https://www.ag-grid.com/charts/archive/14.2.0/vue3/zoom/examples/zoom-buttons/)

Hover near the bottom of the above example to see the default zoom buttons.

- **Zoom out**: Zooms the chart out by one [step](https://www.ag-grid.com/charts/archive/14.2.0/vue/zoom/#scrolling-step).
- **Zoom in**: Zooms the chart in by one [step](https://www.ag-grid.com/charts/archive/14.2.0/vue/zoom/#scrolling-step).
- **Pan left**: Pans the chart to the left by one [step](https://www.ag-grid.com/charts/archive/14.2.0/vue/zoom/#scrolling-step).
- **Pan right**: Pans the chart to the right by one [step](https://www.ag-grid.com/charts/archive/14.2.0/vue/zoom/#scrolling-step).
- **Reset**: Resets the zoom to the original level and position. Equivalent to [Double-Click to Reset](https://www.ag-grid.com/charts/archive/14.2.0/vue/zoom/#double-click-to-reset).

To change when the buttons will appear, use `zoom.buttons.visible`:

- `always` – The buttons will always be visible.
- `zoomed` – The buttons will appear when the chart has been zoomed.
- `hover` – The buttons will appear when the mouse is hovered near the bottom of a chart which has zoom enabled.

### Customisation

It is possible to customise the visibility, order and grouping of buttons, as well as modifying the icon, label text and tooltip for each.

#### Customised Zoom Buttons

```ts
import { createApp, defineComponent, ref } from "vue";
import { AgCharts } from "ag-charts-vue3";
import type { AgChartOptions } from "ag-charts-types";
import {
  AnimationModule,
  ContextMenuModule,
  CrosshairModule,
  LegendModule,
  LineSeriesModule,
  ModuleRegistry,
  NumberAxisModule,
  UnitTimeAxisModule,
  ZoomModule,
} from "ag-charts-enterprise";
import { getData } from "./data";

ModuleRegistry.registerModules([
  AnimationModule,
  CrosshairModule,
  LegendModule,
  LineSeriesModule,
  NumberAxisModule,
  UnitTimeAxisModule,
  ZoomModule,
  ContextMenuModule,
]);

const ChartExample = defineComponent({
  template: `
    <ag-charts
      :options="options"
    />
  `,
  components: {
    "ag-charts": AgCharts,
  },
  setup(props) {
    const options = ref<AgCartesianChartOptions>({
      zoom: {
        enabled: true,
        buttons: {
          visible: "always",
          buttons: [
            {
              icon: "zoom-in",
              tooltip: "Decrease Visible Range",
              value: "zoom-in",
              label: "In",
              section: "zoom",
            },
            {
              icon: "zoom-out",
              tooltip: "Increase Visible Range",
              value: "zoom-out",
              label: "Out",
              section: "zoom",
            },
            {
              icon: "pan-start",
              tooltip: "Pan to Start",
              value: "pan-start",
              section: "pan",
            },
            {
              icon: "pan-end",
              tooltip: "Pan to End",
              value: "pan-end",
              section: "pan",
            },
            {
              tooltip: "Undo all Zoom",
              value: "reset",
              label: "Reset",
              section: "reset",
            },
          ],
        },
      },
      tooltip: {
        enabled: false,
      },
      axes: {
        x: {
          type: "unit-time",
          interval: {
            minSpacing: 50,
            maxSpacing: 200,
          },
          label: {
            autoRotate: false,
          },
          crosshair: {
            label: {
              format: `%d %b %Y`,
            },
          },
        },
      },
      data: getData(),
      series: [
        {
          type: "line",
          xKey: "time",
          yKey: "price",
        },
      ],
    });

    return {
      options,
    };
  },
});

createApp(ChartExample).mount("#app");
```

[Live example: Customised Zoom Buttons](https://www.ag-grid.com/charts/archive/14.2.0/vue3/zoom/examples/zoom-custom-buttons/)

```js
{
    zoom: {
        buttons: {
            visible: 'always',
            buttons: [
                {
                    icon: 'zoom-in',
                    tooltip: 'Decrease Visible Range',
                    value: 'zoom-in',
                    label: 'In',
                    section: 'zoom',
                },
                {
                    icon: 'zoom-out',
                    tooltip: 'Increase Visible Range',
                    value: 'zoom-out',
                    label: 'Out',
                    section: 'zoom',
                },
                {
                    icon: 'pan-start',
                    tooltip: 'Pan to Start',
                    value: 'pan-start',
                    section: 'pan',
                },
                {
                    icon: 'pan-end',
                    tooltip: 'Pan to End',
                    value: 'pan-end',
                    section: 'pan',
                },
                {
                    tooltip: 'Undo all Zoom',
                    value: 'reset',
                    label: 'Reset',
                    section: 'reset',
                },
            ],
        },
    },
}
```

In the above example:

- The pan-left and pan-right buttons are not shown.
- Additional buttons are added to enable panning to the start and end of the x-axis.
- All the buttons have custom tooltip text.
- The order of the zoom-in and zoom-out buttons is swapped and they have a label as well as an icon.
- The reset button has only a label and no icon.

For more information see the [API Reference section](https://www.ag-grid.com/charts/archive/14.2.0/vue/zoom/#reference-AgZoomOptions-buttons-buttons).

## Asynchronous Loading

For loading data asynchronously as the user zooms and pans, see [Asynchronous Data](https://www.ag-grid.com/charts/archive/14.2.0/vue/async-data/).

## Save & Restore

The zoom state can be saved, restored and programmatically initialised and modified, using the [Chart State API](https://www.ag-grid.com/charts/archive/14.2.0/vue/api-state/).

## API Reference

#### Zoom

| Property | Type | Default | Description |
| --- | --- | --- | --- |
| anchorPointX | 'pointer' \| 'start' \| 'middle' \| 'end' | end | The anchor point for the x-axis about which to zoom into when scrolling. |
| anchorPointY | 'pointer' \| 'start' \| 'middle' \| 'end' | middle | The anchor point for the y-axis about which to zoom into when scrolling. |
| autoScaling | AgZoomAutoScaling |  | Zoom auto scaling options. |
| autoScaling.enabled | boolean | true | Set to `false` to disable the auto scaling of the y-axis when zooming the x-axis. |
| autoScaling.padding | Ratio |  | Padding to apply between the zoomed data and the boundary of the series. |
| axes | 'x' \| 'y' \| 'xy' | x | The axes on which to zoom when scrolling, one of `xy`, `x`, or `y`. |
| axisDraggingMode | 'pan' \| 'zoom' | zoom | Whether dragging an axis pans or zooms, if `enableAxisDragging` is enabled. |
| buttons | AgZoomButtons |  | A set of buttons to perform common zoom actions. |
| buttons.buttons | AgZoomButton[] |  | The buttons to show. |
| buttons.buttons.value (required) | 'reset' \| 'zoom-in' \| 'zoom-out' \| 'pan-left' \| 'pan-right' \| 'pan-start' \| 'pan-end' |  | The action to perform when the button is clicked. |
| buttons.buttons.section (required) | string |  | The toolbar section in which to display this button. |
| buttons.buttons.icon | AgIconName |  | Icon to display on the button. |
| buttons.buttons.label | string |  | Text label to display on the button. |
| buttons.buttons.ariaLabel | string |  | Text label to announce in screen readers. |
| buttons.buttons.tooltip | string |  | Tooltip text to display on hover over the button. |
| buttons.visible | 'always' \| 'zoomed' \| 'hover' | 'hover' | When the buttons should be visible. |
| buttons.enabled | boolean |  | Whether the associated elements and properties should be used in the chart. |
| deceleration | 'off' \| 'short' \| 'long' \| Ratio | short | Rate of deceleration of panning when dragging and releasing a zoomed chart. |
| enabled | boolean | false | Set to `true` to enable the zoom module. |
| enableAxisDragging | boolean | true | Set to `true` to enable dragging an axis to zoom series attached to that axis. |
| enableAxisScrolling | boolean | true | Set to `true` to enable scrolling an axis to zoom series attached to that axis. |
| enableDoubleClickToReset | boolean | true | Set to `true` to enable double-clicking to reset the chart to fully zoomed out. |
| enablePanning | boolean | true | Set to `true` to enable panning while zoomed. |
| enableScrolling | boolean | true | Set to `true` to enable zooming with the mouse wheel. |
| enableSelecting | boolean | false | Set to `true` to enable selecting an area of the chart to zoom into. |
| enableTwoFingerZoom | boolean | true | Set to `true` to enable zoom-panning with two touch points. |
| keepAspectRatio | boolean | false | Set to `true` to keep the selection area matching the chart's aspect ratio. |
| minVisibleItems | number | 2 | The minimum number of items to be shown, beyond which zooming is stopped. Set to `0` to allow unlimited zooming. |
| panKey | 'alt' \| 'ctrl' \| 'meta' \| 'shift' | alt | The key that should be pressed to allow dragging to pan around while zoomed, one of `alt`, `ctrl`, `meta` or `shift`. |
| scrollingMode | 'pan' \| 'zoom' | zoom | Whether scrolling the mouse wheel or track pad vertically zooms or pans. |
| scrollingStep | Ratio | 0.1 | The amount to zoom when scrolling with the mouse wheel, as a ratio of the full chart. |
| onDataChange | AgZoomOnDataChange |  | Configuration for how the zoom-pan should respond to data changes |
| onDataChange.strategy | 'reset' \| 'preserveDomain' \| 'preserveRatios' | 'preserveDomain' | The behaviour of how to adjust the zoom when chart data changes. |
| onDataChange.stickToEnd | boolean | false | When `true`, the zoom will be adjusted to ensure that newly appended data is in the viewport. This behaviour only happens if the chart's horizontal viewport is panned all the way to the very end of data range; otherwise the current `strategy` is used instead. |

#### Data Source

| Property | Type | Default | Description |
| --- | --- | --- | --- |
| getData (required) | Function |  | Asynchronous callback to load data into the chart. |


---
product: "AG Charts"
title: "Zoom"
description: "Zoom into Angular charts to navigate large datasets; supports mouse scrolling, panning, selecting, and dragging or enable the navigator / context menu."
enterprise: true
framework: angular
version: "14.2.0"
related:
    - title: "Accessibility"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/accessibility/"
    - title: "Localisation"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/localisation/"
    - title: "Series Highlighting"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/series-highlighting/"
    - title: "Tooltips"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/tooltips/"
    - title: "Touch"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/touch/"
    - title: "Animation"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/animation/"
    - title: "Context Menu"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/context-menu/"
    - title: "Crosshairs & Band Highlight"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/axes-crosshairs/"
    - title: "Data Selection"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/selection/"
    - title: "Flash On Update"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/flash-on-update/"
    - title: "Navigator"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/navigator/"
    - title: "Range Controls"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/range-controls/"
    - title: "Scrollbar"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/scrollbar/"
    - title: "Synchronization"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/sync/"
llms: "https://www.ag-grid.com/charts/archive/14.2.0/llms.txt"
---

# Zoom

AG Charts allows zooming into charts, making it easier to navigate large datasets.

#### Zoom

```ts
// Angular entry point file
import '@angular/compiler';
import { bootstrapApplication } from '@angular/platform-browser';

import { AppComponent } from './app.component';

bootstrapApplication(AppComponent);
```

[Live example: Zoom](https://www.ag-grid.com/charts/archive/14.2.0/angular/zoom/examples/zoom/)

To enable this feature, set `zoom.enabled` to `true`.

```js
{
    zoom: {
        enabled: true,
    },
}
```

In the above example you can:

- Scroll in and out with the mouse wheel or trackpad.
- Zoom and pan using [touch and multi-touch](https://www.ag-grid.com/charts/archive/14.2.0/angular/touch/) functionality.
- Use `+` and `-` keys to zoom in or out (when in focus).
- Click and drag the mouse to pan around the zoomed in chart.
- Click (or touch) and drag an axis to zoom in or out on only that axis.
- Double click (or double tap) anywhere to reset the zoom.
- Double click (or double tap) an axis to reset the zoom on only that axis.

> **Note**
>
> If `axis[].tick.maxSpacing` is provided, the axis ticks and labels will update with the zoom.

## Scrolling

This allows zooming by using the mouse wheel or trackpad, as shown in the above example and is enabled by default. To disable, use `enableScrolling: false`.

### Anchor Point

By default, the chart will zoom while keeping the right side of the x-axis pinned. You can change this anchor point with the `anchorPointX` and `anchorPointY` properties, setting them each to one of:

- `start`, the left or bottom of the chart when scrolling on the x-axis or y-axis respectively,
- `middle` (default for y-axis), the middle of the chart,
- `end` (default for x-axis), the right or top of the chart when scrolling on the x-axis or y-axis respectively,
- `pointer`, keep the mouse pointer above the same position on the chart when zooming.

In the example below, we set the anchor point for both axes to the mouse pointer.

#### Zoom Anchor Point

```ts
// Angular entry point file
import '@angular/compiler';
import { bootstrapApplication } from '@angular/platform-browser';

import { AppComponent } from './app.component';

bootstrapApplication(AppComponent);
```

[Live example: Zoom Anchor Point](https://www.ag-grid.com/charts/archive/14.2.0/angular/zoom/examples/zoom-anchor-point/)

```js
{
    zoom: {
        anchorPointX: 'pointer',
        anchorPointY: 'pointer',
    },
}
```

### Scrolling Step

When scrolling, the chart zooms in by a single step for each movement of the scroll wheel or trackpad. By default `scrollingStep` is set to `0.1`, or 10% of the chart each time.

In the example below, we change the step to `0.4`.

#### Zoom Scrolling Step

```ts
// Angular entry point file
import '@angular/compiler';
import { bootstrapApplication } from '@angular/platform-browser';

import { AppComponent } from './app.component';

bootstrapApplication(AppComponent);
```

[Live example: Zoom Scrolling Step](https://www.ag-grid.com/charts/archive/14.2.0/angular/zoom/examples/zoom-scrolling-step/)

```js
{
    zoom: {
        scrollingStep: 0.4,
    },
}
```

### Axes

By default, scrolling zoom is only enabled for the `x` axis. This can be changed by setting the `axes` property to `x`, `y` or `xy`.

In the example below, we enable zoom on both the `x` and `y` axes.

#### Zoom Axes

```ts
// Angular entry point file
import '@angular/compiler';
import { bootstrapApplication } from '@angular/platform-browser';

import { AppComponent } from './app.component';

bootstrapApplication(AppComponent);
```

[Live example: Zoom Axes](https://www.ag-grid.com/charts/archive/14.2.0/angular/zoom/examples/zoom-axes/)

```js
{
    zoom: {
        axes: 'xy',
    },
}
```

### Scrolling Mode

By default, vertical mouse wheel or trackpad scrolling zooms the chart. Set `scrollingMode: 'pan'` to pan instead.

#### Zoom Scrolling Mode

```ts
// Angular entry point file
import '@angular/compiler';
import { bootstrapApplication } from '@angular/platform-browser';

import { AppComponent } from './app.component';

bootstrapApplication(AppComponent);
```

[Live example: Zoom Scrolling Mode](https://www.ag-grid.com/charts/archive/14.2.0/angular/zoom/examples/zoom-scrolling-mode/)

```js
{
    zoom: {
        scrollingMode: 'pan',
    },
}
```

## Panning

This is enabled by default and allows users to click and drag to move around a zoomed chart. To disable, use `enablePanning: false`.

If [zoom by selecting](https://www.ag-grid.com/charts/archive/14.2.0/angular/zoom/#selecting) is enabled, clicking and dragging will no longer pan by default. Instead the user will need to hold down a key to switch to panning mode.

This key defaults to `alt` but can be set with the `panKey` property to one of `alt`, `ctrl`, `shift` or `meta` (the command key on MacOS or start key on Windows).

In the example below, panning can only be done by holding down the `shift` key while clicking and dragging.

#### Zoom Pan Key

```ts
// Angular entry point file
import '@angular/compiler';
import { bootstrapApplication } from '@angular/platform-browser';

import { AppComponent } from './app.component';

bootstrapApplication(AppComponent);
```

[Live example: Zoom Pan Key](https://www.ag-grid.com/charts/archive/14.2.0/angular/zoom/examples/zoom-pan-key/)

```js
{
    zoom: {
        panKey: 'shift',
    },
}
```

## Selecting

This method of zooming works by clicking and dragging a box to select an area on the chart. This is disabled by default. To enable, use `enableSelecting: true`.

In the example below, the user can only zoom in by selection, and can only zoom out by double-click to reset.

#### Zoom Selecting

```ts
// Angular entry point file
import '@angular/compiler';
import { bootstrapApplication } from '@angular/platform-browser';

import { AppComponent } from './app.component';

bootstrapApplication(AppComponent);
```

[Live example: Zoom Selecting](https://www.ag-grid.com/charts/archive/14.2.0/angular/zoom/examples/zoom-selecting/)

```js
{
    zoom: {
        enableAxisDragging: false,
        enablePanning: false,
        enableScrolling: false,
        enableSelecting: true,
    },
}
```

## Two Finger Zoom-Pan

By default, using two fingers to pinch in or out will zoom the chart. It is also possible to use two fingers to pan a zoomed chart.

To disable this behaviour, use `enableTwoFingerZoom: false`.

#### Two Finger Zoom-Pan Disabled

```ts
// Angular entry point file
import '@angular/compiler';
import { bootstrapApplication } from '@angular/platform-browser';

import { AppComponent } from './app.component';

bootstrapApplication(AppComponent);
```

[Live example: Two Finger Zoom-Pan Disabled](https://www.ag-grid.com/charts/archive/14.2.0/angular/zoom/examples/two-finger-disabled/)

```js
{
    zoom: {
        enableTwoFingerZoom: false,
    },
}
```

In the above example:

- Two fingers gestures are not consumed by the chart. Instead they zoom or scroll the entire page.

## Axis Zoom Controls

By default, a user can click and drag on any axis to change the zoom of that axis. This ignores the `axes` property and is enabled by default for all axes.

#### Axis Zoom Controls

```ts
// Angular entry point file
import '@angular/compiler';
import { bootstrapApplication } from '@angular/platform-browser';

import { AppComponent } from './app.component';

bootstrapApplication(AppComponent);
```

[Live example: Axis Zoom Controls](https://www.ag-grid.com/charts/archive/14.2.0/angular/zoom/examples/zoom-axis-controls/)

- When using `axisDraggingMode: 'zoom'` (default), dragging either of the y-axes will zoom both of them.
- Use `axisDraggingMode: 'pan'` to pan while dragging an axis.
- Use `enableAxisDragging: false` to disable all axis dragging.
- Scrolling on an axis to zoom is enabled by default. Use `enableAxisScrolling: false` to disable it.

## Double-Click to Reset

This allows users to reset the zoom by double-clicking in an empty space in the chart area, and is enabled by default. To disable, use `enableDoubleClickToReset: false`.

## Minimum Visible Items

The `minVisibleItems` option can be used to limit how far a user can zoom in to the chart.

The example below demonstrates setting `minVisibleItems` to `10`, preventing the user from zooming beyond showing a minimum of 10 points on the line.

#### Zoom Min Visible Items

```ts
// Angular entry point file
import '@angular/compiler';
import { bootstrapApplication } from '@angular/platform-browser';

import { AppComponent } from './app.component';

bootstrapApplication(AppComponent);
```

[Live example: Zoom Min Visible Items](https://www.ag-grid.com/charts/archive/14.2.0/angular/zoom/examples/zoom-min-visible-items/)

```js
{
    zoom: {
        minVisibleItems: 10,
    },
}
```

## Auto Scaling

Auto Scaling dynamically adjusts the y-axis to fit the visible data whenever the x-axis is zoomed or panned. This is enabled by default when zooming the x-axis. To disable, use `autoScaling: false`.

#### Auto Scaling

```ts
// Angular entry point file
import '@angular/compiler';
import { bootstrapApplication } from '@angular/platform-browser';

import { AppComponent } from './app.component';

bootstrapApplication(AppComponent);
```

[Live example: Auto Scaling](https://www.ag-grid.com/charts/archive/14.2.0/angular/zoom/examples/auto-scaling/)

```js
{
    zoom: {
        autoScaling: {
            enabled: false,
        },
    },
}
```

In the above example:

- Zoom in to the chart by scrolling and then pan left and right.
- Observe how the vertical axis domain changes to fit the displayed data range.

Auto Scaling is never applied when the user has manually adjusted the y-axis by dragging it. Auto Scaling will be reapplied when the y-axis is reset, for example by double clicking on it.

## On Data Change

When data is updated while the chart is zoomed, the `zoom.onDataChange` options control how the zoomed view adjusts. This helps users maintain their focus when data changes, or always see the latest data.

The default strategy is `preserveDomain`, use `onDataChange.strategy` to change to one of the below.

### Preserve Domain

`strategy: 'preserveDomain'` preserves the current axis domain when data changes, keeping the view at the exact domain values if possible.

This is useful for appending data without disrupting users viewing a specific time period in the middle of the data.

#### Preserve Domain

```ts
// Angular entry point file
import '@angular/compiler';
import { bootstrapApplication } from '@angular/platform-browser';

import { AppComponent } from './app.component';

bootstrapApplication(AppComponent);
```

[Live example: Preserve Domain](https://www.ag-grid.com/charts/archive/14.2.0/angular/zoom/examples/on-data-change-preserve-domain/)

```js
{
    zoom: {
        enabled: true,
        onDataChange: {
            strategy: 'preserveDomain',
        },
    },
}
```

In this example:

- The chart is initially zoomed to the middle of the data.
- Start the updates to see new data appended at the end.
- Notice in the Navigator that new data has been added, but the chart view remains fixed on the same time range.

### Preserve Ratios

`strategy: 'preserveRatios'`, preserves the same zoom percentages regardless of data changes.

This is useful for maintaining a consistent proportional view of your data, with more data points becoming visible as the dataset grows.

#### Preserve Ratios

```ts
// Angular entry point file
import '@angular/compiler';
import { bootstrapApplication } from '@angular/platform-browser';

import { AppComponent } from './app.component';

bootstrapApplication(AppComponent);
```

[Live example: Preserve Ratios](https://www.ag-grid.com/charts/archive/14.2.0/angular/zoom/examples/on-data-change-preserve-ratio/)

```js
{
    zoom: {
        enabled: true,
        onDataChange: {
            strategy: 'preserveRatios',
        },
    },
}
```

In this example:

- The chart is initially zoomed to the last 20% of the data.
- Start the updates to see new data points added in batches.
- Notice that more data points become visible in the chart view as total data grows, since the zoom ratio stays at 80%-100%.

### Reset

`strategy: 'reset'`, resets the zoom to the `initialState` or no zoom, whenever the data changes.

This is useful for switching between unrelated datasets, discarding previous user interactions and reverting to a predefined starting view.

#### Reset

```ts
// Angular entry point file
import '@angular/compiler';
import { bootstrapApplication } from '@angular/platform-browser';

import { AppComponent } from './app.component';

bootstrapApplication(AppComponent);
```

[Live example: Reset](https://www.ag-grid.com/charts/archive/14.2.0/angular/zoom/examples/on-data-change-reset/)

```js
{
    zoom: {
        enabled: true,
        onDataChange: {
            strategy: 'reset',
        },
    },
}
```

In this example:

- The chart is initially zoomed to show only the last few data points.
- Pan or zoom to a different position in the chart.
- Click a button to switch datasets and notice that the zoom resets to the initial state.

### Stick to End

The `stickToEnd` option automatically scrolls to keep the latest data visible when new data is appended and the view is already at the end of the data range. Use `stickToEnd: true` to enable.

When `stickToEnd` is active, it takes precedence over the configured strategy. Once the user pans away from the end, the configured strategy (e.g., `preserveDomain`) takes over until they return to viewing the end.

#### Stick to End

```ts
// Angular entry point file
import '@angular/compiler';
import { bootstrapApplication } from '@angular/platform-browser';

import { AppComponent } from './app.component';

bootstrapApplication(AppComponent);
```

[Live example: Stick to End](https://www.ag-grid.com/charts/archive/14.2.0/angular/zoom/examples/on-data-change-stick-to-end/)

```js
{
    zoom: {
        enabled: true,
        onDataChange: {
            strategy: 'preserveDomain',
            stickToEnd: true,
        },
    },
}
```

In this example:

- The chart is initially zoomed to the end of the data.
- Start the updates to see new data appended and the view scrolls to follow.
- Pan away from the end to see the `preserveDomain` strategy take over with a fixed view.
- Pan back to the end and the view will resume following new data.

## Navigator

The zoom functionality can be used together with the [Navigator](https://www.ag-grid.com/charts/archive/14.2.0/angular/navigator/) to add a visual reference to the zoom position.

## Context Menu

When both the zoom and [Context Menu](https://www.ag-grid.com/charts/archive/14.2.0/angular/context-menu/) are enabled, additional zoom actions are added into the Context Menu for zooming and panning to the clicked location.

#### Zoom Context Menu

```ts
// Angular entry point file
import '@angular/compiler';
import { bootstrapApplication } from '@angular/platform-browser';

import { AppComponent } from './app.component';

bootstrapApplication(AppComponent);
```

[Live example: Zoom Context Menu](https://www.ag-grid.com/charts/archive/14.2.0/angular/zoom/examples/zoom-context-menu/)

## Buttons

Zoom buttons are enabled by default. To disable, use `zoom.buttons.enabled: false`.

#### Zoom Buttons

```ts
// Angular entry point file
import '@angular/compiler';
import { bootstrapApplication } from '@angular/platform-browser';

import { AppComponent } from './app.component';

bootstrapApplication(AppComponent);
```

[Live example: Zoom Buttons](https://www.ag-grid.com/charts/archive/14.2.0/angular/zoom/examples/zoom-buttons/)

Hover near the bottom of the above example to see the default zoom buttons.

- **Zoom out**: Zooms the chart out by one [step](https://www.ag-grid.com/charts/archive/14.2.0/angular/zoom/#scrolling-step).
- **Zoom in**: Zooms the chart in by one [step](https://www.ag-grid.com/charts/archive/14.2.0/angular/zoom/#scrolling-step).
- **Pan left**: Pans the chart to the left by one [step](https://www.ag-grid.com/charts/archive/14.2.0/angular/zoom/#scrolling-step).
- **Pan right**: Pans the chart to the right by one [step](https://www.ag-grid.com/charts/archive/14.2.0/angular/zoom/#scrolling-step).
- **Reset**: Resets the zoom to the original level and position. Equivalent to [Double-Click to Reset](https://www.ag-grid.com/charts/archive/14.2.0/angular/zoom/#double-click-to-reset).

To change when the buttons will appear, use `zoom.buttons.visible`:

- `always` – The buttons will always be visible.
- `zoomed` – The buttons will appear when the chart has been zoomed.
- `hover` – The buttons will appear when the mouse is hovered near the bottom of a chart which has zoom enabled.

### Customisation

It is possible to customise the visibility, order and grouping of buttons, as well as modifying the icon, label text and tooltip for each.

#### Customised Zoom Buttons

```ts
// Angular entry point file
import '@angular/compiler';
import { bootstrapApplication } from '@angular/platform-browser';

import { AppComponent } from './app.component';

bootstrapApplication(AppComponent);
```

[Live example: Customised Zoom Buttons](https://www.ag-grid.com/charts/archive/14.2.0/angular/zoom/examples/zoom-custom-buttons/)

```js
{
    zoom: {
        buttons: {
            visible: 'always',
            buttons: [
                {
                    icon: 'zoom-in',
                    tooltip: 'Decrease Visible Range',
                    value: 'zoom-in',
                    label: 'In',
                    section: 'zoom',
                },
                {
                    icon: 'zoom-out',
                    tooltip: 'Increase Visible Range',
                    value: 'zoom-out',
                    label: 'Out',
                    section: 'zoom',
                },
                {
                    icon: 'pan-start',
                    tooltip: 'Pan to Start',
                    value: 'pan-start',
                    section: 'pan',
                },
                {
                    icon: 'pan-end',
                    tooltip: 'Pan to End',
                    value: 'pan-end',
                    section: 'pan',
                },
                {
                    tooltip: 'Undo all Zoom',
                    value: 'reset',
                    label: 'Reset',
                    section: 'reset',
                },
            ],
        },
    },
}
```

In the above example:

- The pan-left and pan-right buttons are not shown.
- Additional buttons are added to enable panning to the start and end of the x-axis.
- All the buttons have custom tooltip text.
- The order of the zoom-in and zoom-out buttons is swapped and they have a label as well as an icon.
- The reset button has only a label and no icon.

For more information see the [API Reference section](https://www.ag-grid.com/charts/archive/14.2.0/angular/zoom/#reference-AgZoomOptions-buttons-buttons).

## Asynchronous Loading

For loading data asynchronously as the user zooms and pans, see [Asynchronous Data](https://www.ag-grid.com/charts/archive/14.2.0/angular/async-data/).

## Save & Restore

The zoom state can be saved, restored and programmatically initialised and modified, using the [Chart State API](https://www.ag-grid.com/charts/archive/14.2.0/angular/api-state/).

## API Reference

#### Zoom

| Property | Type | Default | Description |
| --- | --- | --- | --- |
| anchorPointX | 'pointer' \| 'start' \| 'middle' \| 'end' | end | The anchor point for the x-axis about which to zoom into when scrolling. |
| anchorPointY | 'pointer' \| 'start' \| 'middle' \| 'end' | middle | The anchor point for the y-axis about which to zoom into when scrolling. |
| autoScaling | AgZoomAutoScaling |  | Zoom auto scaling options. |
| autoScaling.enabled | boolean | true | Set to `false` to disable the auto scaling of the y-axis when zooming the x-axis. |
| autoScaling.padding | Ratio |  | Padding to apply between the zoomed data and the boundary of the series. |
| axes | 'x' \| 'y' \| 'xy' | x | The axes on which to zoom when scrolling, one of `xy`, `x`, or `y`. |
| axisDraggingMode | 'pan' \| 'zoom' | zoom | Whether dragging an axis pans or zooms, if `enableAxisDragging` is enabled. |
| buttons | AgZoomButtons |  | A set of buttons to perform common zoom actions. |
| buttons.buttons | AgZoomButton[] |  | The buttons to show. |
| buttons.buttons.value (required) | 'reset' \| 'zoom-in' \| 'zoom-out' \| 'pan-left' \| 'pan-right' \| 'pan-start' \| 'pan-end' |  | The action to perform when the button is clicked. |
| buttons.buttons.section (required) | string |  | The toolbar section in which to display this button. |
| buttons.buttons.icon | AgIconName |  | Icon to display on the button. |
| buttons.buttons.label | string |  | Text label to display on the button. |
| buttons.buttons.ariaLabel | string |  | Text label to announce in screen readers. |
| buttons.buttons.tooltip | string |  | Tooltip text to display on hover over the button. |
| buttons.visible | 'always' \| 'zoomed' \| 'hover' | 'hover' | When the buttons should be visible. |
| buttons.enabled | boolean |  | Whether the associated elements and properties should be used in the chart. |
| deceleration | 'off' \| 'short' \| 'long' \| Ratio | short | Rate of deceleration of panning when dragging and releasing a zoomed chart. |
| enabled | boolean | false | Set to `true` to enable the zoom module. |
| enableAxisDragging | boolean | true | Set to `true` to enable dragging an axis to zoom series attached to that axis. |
| enableAxisScrolling | boolean | true | Set to `true` to enable scrolling an axis to zoom series attached to that axis. |
| enableDoubleClickToReset | boolean | true | Set to `true` to enable double-clicking to reset the chart to fully zoomed out. |
| enablePanning | boolean | true | Set to `true` to enable panning while zoomed. |
| enableScrolling | boolean | true | Set to `true` to enable zooming with the mouse wheel. |
| enableSelecting | boolean | false | Set to `true` to enable selecting an area of the chart to zoom into. |
| enableTwoFingerZoom | boolean | true | Set to `true` to enable zoom-panning with two touch points. |
| keepAspectRatio | boolean | false | Set to `true` to keep the selection area matching the chart's aspect ratio. |
| minVisibleItems | number | 2 | The minimum number of items to be shown, beyond which zooming is stopped. Set to `0` to allow unlimited zooming. |
| panKey | 'alt' \| 'ctrl' \| 'meta' \| 'shift' | alt | The key that should be pressed to allow dragging to pan around while zoomed, one of `alt`, `ctrl`, `meta` or `shift`. |
| scrollingMode | 'pan' \| 'zoom' | zoom | Whether scrolling the mouse wheel or track pad vertically zooms or pans. |
| scrollingStep | Ratio | 0.1 | The amount to zoom when scrolling with the mouse wheel, as a ratio of the full chart. |
| onDataChange | AgZoomOnDataChange |  | Configuration for how the zoom-pan should respond to data changes |
| onDataChange.strategy | 'reset' \| 'preserveDomain' \| 'preserveRatios' | 'preserveDomain' | The behaviour of how to adjust the zoom when chart data changes. |
| onDataChange.stickToEnd | boolean | false | When `true`, the zoom will be adjusted to ensure that newly appended data is in the viewport. This behaviour only happens if the chart's horizontal viewport is panned all the way to the very end of data range; otherwise the current `strategy` is used instead. |

#### Data Source

| Property | Type | Default | Description |
| --- | --- | --- | --- |
| getData (required) | Function |  | Asynchronous callback to load data into the chart. |
